function getUrlParameter(sParam) {
	var sPageURL = window.location.search.substring(1),
		sURLVariables = sPageURL.split('&'),
		sParameterName,
		i;

	for (i = 0; i < sURLVariables.length; i++) {
		sParameterName = sURLVariables[i].split('=');

		if (sParameterName[0] === sParam) {
			return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
		}
	}
}


(function( $ ) {
	'use strict';

	$(document).ready(function(){

		// $('#current_currency').on('change', function(){
		// 	let current_currency = $(this).val();
		//
		// 	$('.currency_field').removeClass("active");
		//
		// 	if(current_currency === 'USD') {
		// 		$('#north_usd_rate').addClass("active");
		// 	}else {
		// 		$('#north_eur_rate').addClass("active");
		// 	}
		//
		// });

		$('body').on('click', '#et-fb-north_product', function(){
			$(this).attr("placeholder", "Start typing...");
			let container = $(this).parent();
			$(container).find('.search-container').remove();
			$(container).append('<div class="search-container"><div><span>Searching...</span><div class="search-container__loader"></div></div></div>');
		});

		$('body').on('click', '.search-container .product', function(){
			let input = $(this).parent().parent().find("input");
			input.val($(this).data("title"));
			//$(this).parent().hide();
		});

		$('body').on('keyup', '#et-fb-north_product', function(){

			let container = $(this).parent().find('.search-container');

			if($(this).val().length >= 3) {

				let search = $(this).val();

				$.ajax({
					type: 'POST',
					url: ajax_object.ajaxurl,
					data: {
						'action': 'get_products',
						'posts_per_page': -1,
						'search': search
					},
					beforeSend: function() {
						$(container).html('<div><span>Searching...</span><div class="search-container__loader"></div></div>');
						$(container).fadeIn();
					},
					success: function (data) {
						$(container).html(data);
					}
				});
			}else {
				$(container).hide();
			}
		});

		$('body').on('click', '.upload_image_button', function(e) {
			e.preventDefault();
			var send_attachment_bkp = wp.media.editor.send.attachment;
			var button = $(this);
			wp.media.editor.send.attachment = function(props, attachment) {
				$(button).parent().prev().attr('src', attachment.url);
				$(button).prev().val(attachment.id);
				wp.media.editor.send.attachment = send_attachment_bkp;
			}
			wp.media.editor.open(button);
			return false;
		});

// The "Remove" button (remove the value from input type='hidden')
		$('body').on('click', '.remove_image_button', function(e) {
			e.preventDefault();
			var answer = confirm('Are you sure?');
			if (answer === true) {
				var src = $(this).parent().prev().attr('data-src');
				$(this).parent().prev().attr('src', src);
				$(this).prev().prev().val('');
			}
			return false;
		});

		$('body').on('change', '.repeater .variation_primary', function(){
			let current_state = $(this).prop("checked");
			$('.repeater .variation_primary').prop( "checked", false );
			$(this).prop( "checked", current_state );
		})

		$('body').on('change', '.variation_type', function(){
			let type = $(this).val();
			let container = $(this).parent().parent().parent().parent();
			let wrap = container.find('.inner-repeater');

			wrap.removeAttr('class');
			wrap.attr('class', 'inner-repeater ' + type);
		});

		$('.switch-control').click(function(){
			let block = $(this).data("show");
			$('#' + block).fadeToggle("fast");
		});


		$('#variation_repeater').repeater({
			repeaters: [{
				selector: '.inner-repeater'
			}],
		});

		$('#hook_repeater').repeater({
			show: function () {
				$(this).slideDown();
			},
			isFirstItemUndeletable: true,
			defaultValues: {
				'hook_type': 'product_created'
			},
		})

		$('.connect-button.stripe-disconnect').click(function(e) {
			e.preventDefault();

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'stripe_disconnect',
				},
				success: function (data) {
					location.reload();
				}
			});
		});

		$('.connect-button.paypal-disconnect').click(function(e) {
			e.preventDefault();

			let mode = $(this).data('mode');

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'paypal_disconnect',
					'mode': mode
				},
				success: function (data) {
					location.reload();
				}
			});
		});

		$('.paypal-block #test_paypal').on("change", function() {

			let container = $(this).parent().parent();
			let loader = $(this).parent().find('.loader');
			let val = 'on';

			if($(this).prop("checked") == false) {
				val = '';
			}

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'switch_payment_mode',
					'payment_system': 'paypal',
					'payment_value': val,
				},
				beforeSend: function() {
					loader.show();
				},
				success: function (data) {
					loader.hide();
					container.toggleClass("test-mode").toggleClass("live-mode");
				}
			});
		});

		$('.stripe-block #test_stripe').on("change", function() {

			let container = $(this).parent().parent();
			let loader = $(this).parent().find('.loader');
			let val = 'on';

			if($(this).prop("checked") == false) {
				val = '';
			}

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'switch_payment_mode',
					'payment_system': 'stripe',
					'payment_value': val,
				},
				beforeSend: function() {
					loader.show();
				},
				success: function (data) {
					loader.hide();
					container.toggleClass("test-mode").toggleClass("live-mode");
				}
			});
		});

		/**
		 * Load more orders
		 */
		$('.load-more__button').click(function(e) {
			e.preventDefault();

			let that = $(this);
			let action = $(this).data("action");
			let container = $(this).parent().parent().parent();
			let paged, message;
			if (action === "get_orders") {
				paged = ajax_object.order_paged;
				message = "All orders are loaded!";
			}else if(action === "get_products") {
				paged = ajax_object.product_paged;
				message = "All products are loaded!";
			}else {
				paged = ajax_object.coupon_paged;
				message = "All coupons are loaded!";
			}

			let filter = $('.filter-form').serialize();

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': action,
					'paged': paged,
					'posts_per_page': 8,
					'filter': filter,
				},
				beforeSend: function() {
					$(container).find('.load-more__loader').show();
				},
				success: function (data) {
					$(container).find('.load-more__loader').hide();
					if(data === 'error') {
						$(container).find('.north-error').text(message).show();
					}else {
						$(container).find('.item-container').append(data);

						if (action === "get_orders") {
							ajax_object.order_paged++;
						}else if (action === "get_products") {
							ajax_object.product_paged++;
						}else {
							ajax_object.coupon_paged++;
						}
					}

				}
			});
		});

		/**
		 * Filter orders
		 */
		$('#orders-filter').submit(function(e) {
			e.preventDefault();

			let form = $(this).serialize();
			let container = $(this).parent().parent();

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'get_orders',
					'posts_per_page': 8,
					'filter': form,
				},
				beforeSend: function() {
					$(container).find('.filter-loader.load-more__loader').show();
				},
				success: function (data) {
					$(container).find('.filter-loader.load-more__loader').hide();
					if(data === 'error') {
						$(container).find('.item-container').html('');
						$(container).find('.north-error').text("Orders not found.").show();
					}else {
						$(container).find('.item-container').html(data);
						ajax_object.order_paged = 2;
					}

				}
			});
		});

		$('.radio-container').click(function(){
			let tab = $(this).find('input').attr("id");
			$('.tab').hide();
			$('.tab.' + tab).show();

			if(tab !== 'onetime_plan') {
				$('#is_variable').removeAttr("checked");
				$('#variation_repeater').hide();
			}
		});

		$('#product_frequency').change(function(){
			$('.change-word-product').text($(this).val());
		});

		$('#bump_frequency').change(function(){
			$('.change-word-bump').text($(this).val());
		});

		$('.submit-btn').click(function(e){
			$(this).parent().find('.loader').show();
		});

		$('body').on("click", ".coupon__delete-button", function(){
			let coupon_id = $(this).data("coupon-id");

			$('.modal-delete a.delete').data("id", coupon_id);
			$('.modal-delete a.delete').data("type", "coupon");
			$('.modal-delete').fadeIn("fast");
		});

		$('body').on("click", ".product__delete-button", function(){
			let product_id = $(this).data("product-id");

			$('.modal-delete a.delete').data("id", product_id);
			$('.modal-delete a.delete').data("type", "product");
			$('.modal-delete').fadeIn("fast");
		});

		$('body').on("click", ".order__delete button", function(e){
			e.preventDefault();
			let order_id = $(this).data("order-id");

			$('.modal-delete a.delete').data("id", order_id);
			$('.modal-delete a.delete').data("type", "order");
			$('.modal-delete').fadeIn("fast");
		});

		$('.modal-delete a.delete').on("click", function(){
			let that = $(this);
			let action = 'delete_' + that.data("type");
			let id = that.data("id");

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': action,
					'delete_id': id
				},
				beforeSend() {
					$('.modal-delete .loader').show();
				},
				success: function (data) {
					$('.modal-delete .loader').hide();
					$('.modal').hide();
					location.reload();
				}
			});

		});

		$('.modal-delete a.cancel').click(function(){
			$('.modal-delete').hide();
		});

		$('.sync-product').click(function(){

			let loader = $(this).parent().find('.loader');
			let loader_message = $(this).parent().find('.loader-message');

			$.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'sync_products',
					'ajax_response': 'true'
				},
				beforeSend() {
					loader_message.hide();
					loader.show();
				},
				success: function (data) {
					loader.hide();
					loader_message.text("Synchronization completed successfully").show();
					console.log(data);
				}
			});
		});

	});

})( jQuery );
