<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/coupon
 */

?>

<div class="coupons-tab__body">
    <form id="coupon_edit" method="POST">

        <label for="">Coupon name</label>
        <input type="text" id="coupon_name" name="coupon_name" value="<?php echo Clean::str($coupon_name); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">

        <div class="field-row one-fourth">
            <div class="field-column">
                <label for="coupon_type">Discount type</label>
                <select id="coupon_type" name="coupon_type">
                    <option value="fixed" <?php if (!empty($coupon_type) && Clean::str($coupon_type) == 'fixed') {
                        echo 'selected="selected"';
                    } ?>>Fixed discount
                    </option>
                    <option value="percentage" <?php if (!empty($coupon_type) && Clean::str($coupon_type) == 'percentage') {
                        echo 'selected="selected"';
                    } ?>>Percent discount
                    </option>
                </select>
            </div>
            <div class="field-column">
                <label for="coupon_status">Coupon status</label>
                <select id="coupon_status" name="coupon_status">
                    <option value="active" <?php if (!empty($coupon_status) && Clean::str($coupon_status) == 'active') {
                        echo 'selected="selected"';
                    } ?>>Active
                    </option>
                    <option value="not_active" <?php if (!empty($coupon_status) && Clean::str($coupon_status) == 'not_active') {
                        echo 'selected="selected"';
                    } ?>>Disabled
                    </option>
                </select>
            </div>
            <div class="field-column">
                <label for="coupon_price">Price of coupon</label>
                <input type="number" id="coupon_price" name="coupon_price" min="0" step="0.01"
                       value="<?php echo !empty($coupon_price) ? Clean::float($coupon_price) : 0; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
            </div>
            <div class="field-column">
                <label for="coupon_limit">Usage limits</label>
                <input type="number" id="coupon_limit" name="coupon_limit" value="<?php echo strlen($coupon_limit) ?  $coupon_limit : ''; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
            </div>
        </div>

        <div class="submit-wrap">
            <?php if (isset($_GET['action']) && $_GET['action'] == 'add') : // phpcs:ignore WordPress.Security.NonceVerification.Recommended ?>
                <input type="submit" class="btn submit-btn" name="submit_create" value="Create coupon">
            <?php else:; ?>
                <input type="submit" class="btn submit-btn" name="submit_update" value="Update coupon">
            <?php endif; ?>
            <div class="loader load-more__loader"></div>
        </div>

    </form>
</div>