<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/coupon
 */

$coupon_id = get_the_ID();
$limit = get_post_meta($coupon_id, 'coupon_limit', true);
$status = get_post_status( $coupon_id );

?>

<div class="coupon coupon-<?php echo get_the_ID(); ?>">
    <div class="coupon__wrap">
        <h4 class="coupon__title coupon-column-1">
            <a href="<?php echo esc_url( site_url() ) . '/wp-admin/admin.php?page=north-checkout-coupons&action=edit&id=' . get_the_ID() ; ?>"><?php echo esc_html( get_the_title() ); ?></a>
        </h4>
        <p class="price coupon-column-2"><?php echo $coupon_price; ?></p> <?php // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped?>
        <p class="price coupon-column-3"><?php echo get_post_status_object( $status )->label; ?></p>
        <p class="price coupon-column-4"><?php echo ($limit != '') ? $limit : '&#8734;'; ?></p>
        <div class="coupon-column-5">
            <a href="<?php echo esc_url( site_url() ) . '/wp-admin/admin.php?page=north-checkout-coupons&action=edit&id=' . get_the_ID() ; ?>" id="coupon-edit" class="coupon__edit-button">Edit Coupon</a>
        </div>
        <div class="coupon-column-6">
            <a class="coupon__delete-button" data-coupon-id="<?php the_ID(); ?>">Delete Coupon</a>
        </div>
    </div>
</div>