<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/order
 */

$north_id = get_the_ID();
$bump_id = get_post_meta(get_the_ID(), 'bump_id', true );
$order_bump = '';

$product_success = get_post_meta(get_the_ID(), 'product_payment_status', true );
$bump_success = get_post_meta(get_the_ID(), 'bump_payment_status', true );

$product_success = $product_success === 'false' ? 'error' : '';
$bump_success = $bump_success === 'false' ? 'error' : '';

if ($bump_id) {
    $order_bump = '<br><b>Order bump: </b><span class="'.$bump_success.'">' . esc_html( get_the_title($bump_id)) . '</span>';
}

$customer_name = get_post_meta($north_id, 'customer_name', true ) !== " " ? get_post_meta($north_id, 'customer_name', true ) : '';
$currency = get_post_meta($north_id, 'product_currency', true);
$total = number_format(floatval(get_post_meta($north_id, 'total', true)), 2);
$qty = get_post_meta($north_id, 'product_quantity', true) ? intval(get_post_meta($north_id, 'product_quantity', true)) : 1;

?>
<?php do_action('north_before_single_order_item'); ?>
<a href="<?php echo esc_url( site_url() ) . '/wp-admin/admin.php?page=north-checkout-orders&view=' . get_the_ID(); ?>" class="order order-<?php the_ID(); ?>">
    <div class="order__wrap">
        <span class="order__status-dot <?php echo esc_html( get_post_status() ); ?>"></span>
        <span class="order__number order-column-1"><?php echo esc_html( get_the_title() ); ?></span>
        <h4 class="order__customer order-column-2"><?php echo esc_html( $customer_name ); ?></h4>
        <p class="order__details order-column-3">
            <?php
                echo '<b>Product: </b><span class="'.$product_success.'">' . esc_html( get_post_meta($north_id, 'product_name', true )) . '</span>';
                echo ( isset($variations) && !empty($variations) ) ? wp_kses( $variations, 'post' ) : '';
                echo $order_bump; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
        </p>
        <p class="order__qty order-column-4"><?php echo $qty; ?></p>
        <p class="order__total order-column-5"><?php echo esc_html(North_Checkout_Admin::formatted_price($total, false, $currency)); ?></p>
        <p class="order__date order-column-6"><?php echo get_the_date('m/d/Y'); ?></p>
        <span class="order__status order-column-7 <?php echo esc_html( get_post_status() ); ?>"><span><?php echo esc_html( get_post_status_object(get_post_status())->label ); ?></span></span>
        <div class="order__delete order-column-8"><button data-order-id="<?php echo get_the_ID(); ?>">&#9587;</button></div>
    </div>
</a>
<?php do_action('north_after_single_order_item'); ?>