<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/product
 */

?>

<div class="products-tab__body">
    <form id="product_edit" method="POST">

        <label for="">Product name</label>
        <input type="text" id="product_name" name="product_name" value="<?php echo Clean::str($product_name); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">

        <div class="product_type-wrap">
            <h3>Subscription, Payment Plan, or One-Time Product</h3>
            <p>Is this product available as a subscription, a payment plan, or a one-time sell?</p>

            <label class="radio-container">Subscription
                <input type="radio" name="product_type" id="subscribtion_type"
                       value="Subscription" <?php if (!empty($product_type) && $product_type == 'Subscription') {
                    echo 'checked';
                } ?>>
                <span class="checkmark"></span>
            </label>
            <label class="radio-container">Payment Plan
                <input type="radio" name="product_type" id="pplan_type"
                       value="Payment Plan" <?php if (!empty($product_type) && $product_type == 'Payment Plan') {
                    echo 'checked';
                } ?>>
                <span class="checkmark"></span>
            </label>
            <label class="radio-container">One-time
                <input type="radio" name="product_type" id="onetime_type"
                       value="One time" <?php if (!empty($product_type) && $product_type == 'One time') {
                    echo 'checked';
                } ?>>
                <span class="checkmark"></span>
            </label>

            <div class="field-row first-row">
                <div class="field-column">
                    <label for="product_price">Price of product</label>
                    <input type="number" id="product_price" name="product_price" min="0" step="0.01"
                           value="<?php echo !empty($product_price) ? Clean::float($product_price) : 0; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                </div>
                <div class="field-column">
                    <label for="product_quantity">Quantity</label>
                    <input type="number" id="product_quantity" name="product_quantity"
                        value="<?php echo ! empty( $product_quantity ) && strlen( $product_quantity ) ?  Clean::int( $product_quantity ) : ''; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                </div>
            </div>

            <div class="tab subscribtion_type" <?php if ($product_type == 'Subscription') {
                echo 'style="display: block"';
            } ?> >
                <div class="field-row">
                    <div class="field-column">
                        <label for="product_trial_count">Free trial (optional)</label>
                        <input type="number" id="product_trial_count" name="product_trial_count" min="0"
                               value="<?php echo !empty($product_trial_count) ? Clean::float($product_trial_count) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                    </div>
                    <div class="field-column">
                        <label for="product_trial_type">Type</label>
                        <select id="product_trial_type" name="product_trial_type">
                            <option value="Days" <?php if (!empty($product_trial_type) && Clean::str($product_trial_type) === 'Days') {
                                echo 'selected="selected"';
                            } ?>>Days
                            </option>
                            <option value="Month" <?php if (!empty($product_trial_type) && Clean::str($product_trial_type) === 'Month') {
                                echo 'selected="selected"';
                            } ?>>Month
                            </option>
                        </select>
                    </div>
                    <p class="hint">Leave trial field empty if you don't want use trial or set your trial terms in days
                        or months</p>
                </div>
                <div class="field-row">
                    <div class="field-column">
                        <label for="product_frequency">Frequency</label>
                        <select id="product_frequency" name="product_frequency_sub">
                            <option value="week" <?php if (!empty($product_frequency_sub) && Clean::str($product_frequency_sub) == 'week') {
                                echo 'selected="selected"';
                            } ?>>Weekly
                            </option>
                            <option value="month" <?php if (!empty($product_frequency_sub) && Clean::str($product_frequency_sub) == 'month') {
                                echo 'selected="selected"';
                            } ?>>Monthly
                            </option>
                            <option value="year" <?php if (!empty($product_frequency_sub) && Clean::str($product_frequency_sub) == 'year') {
                                echo 'selected="selected"';
                            } ?>>Yearly
                            </option>
                        </select>
                    </div>
                    <div class="field-column">
                        <label for="product_start_price_sub">Price for first <span
                                    class="change-word-product"><?php echo !empty($product_frequency_sub) ? $product_frequency_sub : 'week'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></span>
                            (optional)</label>
                        <input type="number" id="product_start_price_sub" name="product_start_price_sub" min="0" step="0.01"
                               value="<?php echo !empty($product_start_price_sub) ? Clean::float($product_start_price_sub) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                    </div>
                    <p class="hint">Set the frequency of your billing and if you want a varying price for the first
                        week, month or year, add a price for first (week, month or year)</p>
                </div>
            </div>

            <div class="tab pplan_type" <?php if ($product_type == 'Payment Plan') {
                echo 'style="display: block"';
            } ?>>
                <div class="field-row one-third">
                    <div class="field-column">
                        <label for="product_start_price">First payment (Optional)</label>
                        <input type="number" id="product_start_price" name="product_start_price" min="0" step="0.01"
                               value="<?php echo !empty($product_start_price) ? Clean::float($product_start_price) : '0'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                    </div>
                    <div class="field-column">
                        <label for="product_payment_number">Number of payments</label>
                        <input type="number" id="product_payment_number" name="product_payment_number" min="0"
                               value="<?php echo !empty($product_payment_number) ? Clean::float($product_payment_number) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                    </div>
                    <div class="field-column">
                        <label for="product_frequency">Frequency</label>
                        <select id="product_frequency" name="product_frequency">
                            <option value="week" <?php if (!empty($product_frequency) && Clean::str($product_frequency) == 'week') {
                                echo 'selected="selected"';
                            } ?>>Weekly
                            </option>
                            <option value="month" <?php if (!empty($product_frequency) && Clean::str($product_frequency) == 'month') {
                                echo 'selected="selected"';
                            } ?>>Monthly
                            </option>
                            <option value="year" <?php if (!empty($product_frequency) && Clean::str($product_frequency) == 'year') {
                                echo 'selected="selected"';
                            } ?>>Yearly
                            </option>
                        </select>
                    </div>
                </div>
            </div>

            <div class="bump-section">
                <div class="bump-section__pre">
                    <h3>Bump Pricing</h3>
                    <p>Check this box to customize product is product is an order bump.</p>
                    <label class="switch">
                        <input type="checkbox" name="reload_bump" id="reload_bump" class="switch-control"
                               data-show="bump_data" <?php if ($this->reload_bump()) {
                            echo 'checked';
                        } ?>>
                        <span class="slider round"></span>
                    </label>
                </div>
                <div id="bump_data" class="bump_data" <?php if ($this->reload_bump()) {
                    echo 'style="display: block;"';
                } ?>>
                    <div class="field-row first-row">
                        <div class="field-column">
                            <label for="bump_price">Bump Price</label>
                            <input type="number" id="bump_price" name="bump_price" min="0" step="0.01"
                                   value="<?php echo !empty($bump_price) ? Clean::float($bump_price) : 0; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped?>">
                        </div>
                        <div class="field-column">
                            <label for="bump_quantity">Quantity</label>
                            <input type="number" id="bump_quantity" name="bump_quantity" min="0"
                                   value="<?php echo !empty($bump_quantity) ? Clean::int($bump_quantity) : 0; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                        </div>
                    </div>
                    <div class="tab subscribtion_type" <?php if ($product_type == 'Subscription') {
                        echo 'style="display: block"';
                    } ?> >
                        <div class="field-row">
                            <div class="field-column">
                                <label for="bump_trial_count">Free trial (optional)</label>
                                <input type="number" id="bump_trial_count" name="bump_trial_count" min="0"
                                       value="<?php echo !empty($bump_trial_count) ? Clean::int($bump_trial_count) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                            </div>
                            <div class="field-column">
                                <label for="bump_trial_type">Type</label>
                                <select id="bump_trial_type" name="bump_trial_type">
                                    <option value="Days" <?php if (!empty($bump_trial_type) && $bump_trial_type == 'Days') {
                                        echo 'selected="selected"';
                                    } ?>>Days
                                    </option>
                                    <option value="Month" <?php if (!empty($bump_trial_type) && $bump_trial_type == 'Month') {
                                        echo 'selected="selected"';
                                    } ?>>Month
                                    </option>
                                </select>
                            </div>
                            <p class="hint">Leave trial field empty if you don't want use trial or set your trial terms
                                in days or months</p>
                        </div>
                        <div class="field-row">
                            <div class="field-column">
                                <label for="bump_frequency">Frequency</label>
                                <select id="bump_frequency" name="bump_frequency_sub">
                                    <option value="week" <?php if (!empty($bump_frequency_sub) && $bump_frequency_sub == 'week') {
                                        echo 'selected="selected"';
                                    } ?>>Weekly
                                    </option>
                                    <option value="month" <?php if (!empty($bump_frequency_sub) && $bump_frequency_sub == 'month') {
                                        echo 'selected="selected"';
                                    } ?>>Monthly
                                    </option>
                                    <option value="year" <?php if (!empty($bump_frequency_sub) && $bump_frequency_sub == 'year') {
                                        echo 'selected="selected"';
                                    } ?>>Yearly
                                    </option>
                                </select>
                            </div>
                            <div class="field-column">
                                <label for="bump_start_price_sub">Price for first <span
                                            class="change-word-bump"><?php echo !empty($bump_frequency_sub) ? esc_html( $bump_frequency_sub ) : 'week'; ?></span>
                                    (optional)</label>
                                <input type="number" id="bump_start_price_sub" name="bump_start_price_sub" min="0" step="0.01"
                                       value="<?php echo !empty($bump_start_price_sub) ? Clean::float($bump_start_price_sub) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                            </div>
                            <p class="hint">Set the frequency of your billing and if you want a varying price for the
                                first week, month or year, add a price for first (week, month or year)</p>
                        </div>
                    </div>

                    <div class="tab pplan_type" <?php if ($product_type == 'Payment Plan') {
                        echo 'style="display: block"';
                    } ?>>
                        <div class="field-row one-third">
                            <div class="field-column">
                                <label for="bump_start_price">First payment (Optional)</label>
                                <input type="number" id="bump_start_price" name="bump_start_price" min="0" step="0.01"
                                       value="<?php echo !empty($bump_start_price) ? Clean::float($bump_start_price) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>">
                            </div>
                            <div class="field-column">
                                <label for="bump_payment_number">Number of payments</label>
                                <input type="number" id="bump_payment_number" name="bump_payment_number" min="0"
                                       value="<?php echo !empty($bump_payment_number) ? Clean::int($bump_payment_number) : null; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped?>">
                            </div>
                            <div class="field-column">
                                <label for="bump_frequency">Frequency</label>
                                <select id="bump_frequency" name="bump_frequency">
                                    <option value="week" <?php if (!empty($bump_frequency) && $bump_frequency == 'week') {
                                        echo 'selected="selected"';
                                    } ?>>Weekly
                                    </option>
                                    <option value="month" <?php if (!empty($bump_frequency) && $bump_frequency == 'month') {
                                        echo 'selected="selected"';
                                    } ?>>Monthly
                                    </option>
                                    <option value="year" <?php if (!empty($bump_frequency) && $bump_frequency == 'year') {
                                        echo 'selected="selected"';
                                    } ?>>Yearly
                                    </option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="tab onetime_type" <?php if ($product_type == 'One time') {
                echo 'style="display: block"';
            } ?>>
                <div class="variation-wrap">
                    <div class="variation-section">
                        <h3>Variable product</h3>
                        <p>Should this product be variable?</p>
                        <label class="switch">
                            <input type="checkbox" name="is_variable" id="is_variable" class="switch-control"
                                   data-show="variation_repeater" <?php if ($this->is_variable()) {
                                echo 'checked';
                            } ?>>
                            <span class="slider round"></span>
                        </label>
                    </div>
                    <div id="variation_repeater" class="repeater" <?php if ($this->is_variable()) {
                        echo 'style="display: block;"';
                    } ?>>
                        <div data-repeater-list="variations">
                            <?php if (isset($variations) && !empty($variations)) : ?>
                                <?php foreach ($variations as $key => $value) : ?>
                                    <div class="repeater-row variation-row" data-repeater-item>

                                        <div class="field-row">
                                            <div class="field-column">
                                                <label for="variation_name">Variation name</label>
                                                <input type="text" id="variation_name" name="variation_name"
                                                       value="<?php echo esc_attr( $value["variation_name"] ); ?>">
                                            </div>
                                            <div class="field-column btn-variable right-controls">
                                                <div>
                                                    <label for="variation_name">Type</label>
                                                    <select id="variation_type" class="variation_type" name="variation_type">
                                                        <option value="select" <?php echo isset($value["variation_type"]) && $value["variation_type"] === "select" ? 'selected' : ''; ?>>Select</option>
                                                        <option value="text" <?php echo isset($value["variation_type"]) && $value["variation_type"] === "text" ? 'selected' : ''; ?>>Text</option>
                                                        <option value="color" <?php echo isset($value["variation_type"]) && $value["variation_type"] === "color" ? 'selected' : ''; ?>>Color</option>
                                                        <option value="image" <?php echo isset($value["variation_type"]) && $value["variation_type"] === "image" ? 'selected' : ''; ?>>Image</option>
                                                        <option value="label" <?php echo isset($value["variation_type"]) && $value["variation_type"] === "label" ? 'selected' : ''; ?>>Label</option>
                                                    </select>
                                                </div>
                                                <div>
                                                    <label for="variation_primary">Make primary <span
                                                                class="hint-point">?<span class="hint-text">Set this variation's price as the default price.</span></span></label>
                                                    <label class="switch">
                                                        <input type="checkbox" id="variation_primary"
                                                               name="variation_primary" class="variation_primary"
                                                               value="on" <?php if (isset($value['variation_primary'])) {
                                                            echo 'checked';
                                                        } ?>>
                                                        <span class="slider round"></span>
                                                    </label>
                                                </div>
                                            </div>
                                        </div>

                                        <button class="delete-button" data-repeater-delete><span>-</span></button>

                                        <!-- innner repeater -->
                                        <div class="inner-repeater <?php echo esc_attr( $value["variation_type"] ); ?>">
                                            <div data-repeater-list="values">

                                                <div class="field-row repeater-heading">
                                                    <div class="field-column">
                                                        <label>Attribute</label>
                                                    </div>
                                                    <div class="field-column">
                                                        <label>Price</label>
                                                    </div>
                                                    <div class="field-column last color">
                                                        <label>Color</label>
                                                    </div>
                                                    <div class="field-column last image">
                                                        <label>Image</label>
                                                    </div>
                                                    <div class="field-column last label">
                                                        <label>Label</label>
                                                    </div>
                                                </div>

                                                <?php
                                                $value['values'] = isset( $value['values'] ) ? $value['values'] : [];
                                                foreach ($value['values'] as $key => $val) : ?>
                                                    <div class="field-row repeater-row" data-repeater-item>
                                                        <div class="field-column">
                                                            <input type="text" id="variation_attribute"
                                                                   name="variation_attribute" value="<?php echo isset($val['variation_attribute']) ? esc_attr( $val['variation_attribute'] ) : ''; ?>">
                                                        </div>
                                                        <div class="field-column">
                                                            <input type="text" id="variation_price" name="variation_price" value="<?php echo isset($val['variation_price']) ? esc_attr( $val['variation_price'] ) : ''; ?>">
                                                        </div>
                                                        <div class="field-column last color">
                                                            <input type="color" id="variation_color" name="variation_color" value="<?php echo isset($val['variation_color']) ? esc_attr( $val['variation_color'] ) : '#1f57ff'; ?>">
                                                        </div>
                                                        <div class="field-column last image">
                                                            <?php $image = $val['variation_image'] ? wp_get_attachment_url($val['variation_image']) : esc_url( plugin_dir_url(__FILE__) ) .'../../../admin/images/200.jpg'; ?>
                                                            <img data-src="<?php echo esc_url( plugin_dir_url(__FILE__) ) .'../../../admin/images/200.jpg'; ?>" src="<?php echo esc_url( $image ); ?>" width="50px" height="50px" />
                                                            <div>
                                                                <input type="hidden" name="variation_image" id="variation_image" value="<?php echo isset($val['variation_image']) ? esc_attr( $val['variation_image'] ) : ''; ?>" />
                                                                <button type="submit" class="upload_image_button button">Upload</button>
                                                                <button type="submit" class="remove_image_button button">Remove</button>
                                                            </div>
                                                        </div>
                                                        <div class="field-column last label">
                                                            <input type="text" id="variation_label" name="variation_label" value="<?php echo esc_attr( $val['variation_label'] ); ?>">
                                                        </div>
                                                        <button class="delete-button" data-repeater-delete><span>-</span>
                                                        </button>
                                                    </div>
                                                <?php endforeach; ?>

                                            </div>
                                            <input data-repeater-create type="button" class="btn add-value" value="Add new attribute"/>
                                        </div>

                                    </div>
                                <?php endforeach; ?>
                            <?php else:; ?>
                                <div class="repeater-row variation-row" data-repeater-item>

                                    <div class="field-row">
                                        <div class="field-column">
                                            <label for="variation_name">Variation name</label>
                                            <input type="text" id="variation_name" name="variation_name">
                                        </div>
                                        <div class="field-column btn-variable right-controls">
                                            <div>
                                                <label for="variation_name">Type</label>
                                                <select id="variation_type" class="variation_type" name="variation_type">
                                                    <option value="select" selected>Select</option>
                                                    <option value="text">Text</option>
                                                    <option value="color">Color</option>
                                                    <option value="image">Image</option>
                                                    <option value="label">Label</option>
                                                </select>
                                            </div>
                                            <div>
                                                <label for="variation_primary">Make primary <span class="hint-point">?<span class="hint-text">Set this variation's price as the default price.</span></label>
                                                <label class="switch">
                                                    <input type="checkbox" id="variation_primary" name="variation_primary" class="variation_primary" value="on">
                                                    <span class="slider round"></span>
                                                </label>
                                            </div>
                                        </div>
                                    </div>

                                    <button class="delete-button" data-repeater-delete><span>-</span></button>

                                    <!-- innner repeater -->
                                    <div class="inner-repeater">
                                        <div data-repeater-list="values">

                                            <div class="field-row repeater-heading">
                                                <div class="field-column">
                                                    <label>Attribute</label>
                                                </div>
                                                <div class="field-column">
                                                    <label>Price</label>
                                                </div>
                                                <div class="field-column last color">
                                                    <label>Color</label>
                                                </div>
                                                <div class="field-column last image">
                                                    <label>Image</label>
                                                </div>
                                                <div class="field-column last label">
                                                    <label>Label</label>
                                                </div>
                                            </div>

                                            <div class="field-row repeater-row" data-repeater-item>
                                                <div class="field-column">
                                                    <input type="text" id="variation_attribute" name="variation_attribute">
                                                </div>
                                                <div class="field-column">
                                                    <input type="text" id="variation_price" name="variation_price">
                                                </div>
                                                <div class="field-column last color">
                                                    <input type="color" id="variation_color" name="variation_color" value="#1f57ff">
                                                </div>
                                                <div class="field-column last image">
                                                    <img data-src="<?php echo esc_url( plugin_dir_url(__FILE__) ) .'../../../admin/images/200.jpg'; ?>" src="<?php echo esc_url( plugin_dir_url(__FILE__) ) .'../../../admin/images/200.jpg'; ?>" width="50px" height="50px" />
                                                    <div>
                                                        <input type="hidden" name="variation_image" id="variation_image"/>
                                                        <button type="submit" class="upload_image_button button">Upload</button>
                                                        <button type="submit" class="remove_image_button button">Remove</button>
                                                    </div>
                                                </div>
                                                <div class="field-column last label">
                                                    <input type="text" id="variation_label" name="variation_label">
                                                </div>
                                                <button class="delete-button" data-repeater-delete><span>-</span></button>
                                            </div>

                                        </div>

                                        <input data-repeater-create type="button" class="btn add-value"
                                               value="Add new attribute"/>
                                    </div>
                                </div>
                            <?php endif; ?>
                        </div>
                        <input data-repeater-create type="button" class="btn" value="Add variation"/>
                    </div>
                </div>
            </div>

            <div class="submit-wrap">
                <?php if (isset($_GET['action']) && $_GET['action'] == 'add') : // phpcs:ignore WordPress.Security.NonceVerification.Recommended ?>
                    <input type="submit" class="btn submit-btn" name="submit_create" value="Create product">
                <?php else:; ?>
                    <input type="submit" class="btn submit-btn" name="submit_update" value="Update product">
                <?php endif; ?>
                <div class="loader load-more__loader"></div>
            </div>
        </div>
    </form>
</div>