<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/product
 */

$bump_text = '';

if(isset($bump_price)) {
    $bump_text = '<br><b>Bump: </b>' . $bump_price;
}

$paypal_active = !empty($paypal_active) ? 'active' : '';
$stripe_active = !empty($stripe_active) ? 'active' : '';
$regular = '';

if(isset($product_type) && $product_type === 'One time') {
    $regular = 'one-time';
}

?>
<?php do_action('north_before_single_product_item'); ?>
<div class="product product-<?php echo get_the_ID() . ' ' . esc_html( $regular ); ?>">
    <div class="product__wrap">
        <h4 class="product__title product-column-1">
            <a href="<?php echo esc_url( site_url() ) . '/wp-admin/admin.php?page=north-checkout-products&action=edit&id=' . get_the_ID() ; ?>"><?php echo '#' . esc_html( get_post_meta(get_the_ID(), 'product_number', true) ) . ' - ' . esc_html( get_the_title() ); ?></a>
        </h4>
        <p class="price product-column-2"><b>Product: </b> <?php echo $product_price . $bump_text ; ?></p> <?php // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped?>
        <div class="product-column-3">
            <a href="<?php echo esc_url( site_url() ) . '/wp-admin/admin.php?page=north-checkout-products&action=edit&id=' . get_the_ID() ; ?>" id="product-edit" class="product__edit-button">Edit Product</a>
        </div>
        <div class="product-column-4">
            <a class="product__delete-button" data-product-id="<?php the_ID(); ?>">Delete Product</a>
        </div>
        <?php if(!$regular) : ?>
            <div class="product__paypal-status product-column-5"><span class="payment_status <?php echo esc_html( $paypal_active ); ?>"></span></div>
            <div class="product__stripe-status product-column-6"><span class="payment_status <?php echo esc_html( $stripe_active ); ?>"></span></div>
        <?php endif; ?>
    </div>
</div>
<?php do_action('north_after_single_product_item'); ?>