<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the select variation type.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/product
 */

$counter = 0;
?>

    <div class="variation-column"><h5><?php echo esc_html( $variation["variation_name"] ); ?></h5>
        <div class="checkout_field_color">

            <?php if (isset($variation['variation_primary']) && $variation['variation_primary'][0] === 'on') : ?>

                <?php foreach ($variation["values"] as $key => $value) {

                    if ($counter == 0) {
                        $is_selected = 'checked="checked"';
                        $variation_price = Clean::float($value["variation_price"]);
                    } else {
                        $is_selected = '';
                    } ?>

                    <label class="variation-container" data-selected="<?php echo esc_attr( $is_selected ); ?>">
                        <input type="radio" class="variation-price-change" name="variation_<?php echo esc_html(strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>" <?php echo esc_html( $is_selected ); ?> data-price="<?php echo esc_attr( $value["variation_price"] ); ?>" data-module-num="<?php echo esc_attr( $current_module ); ?>" value="<?php echo esc_attr( $value["variation_attribute"] ); ?>">
                        <span class="checkmark" style="border-color: <?php echo esc_attr( $value["variation_color"] ); ?>; background-color: <?php echo esc_attr( $value["variation_color"] ); ?>"></span>
                    </label>
                    <?php
                    $counter++;
                } ?>

            <?php $counter = 0; else:; ?>

                <?php foreach ($variation["values"] as $key => $value) : $is_selected = $counter == 0 ? 'checked="checked"' : ''; ?>

                    <label class="variation-container">
                        <input type="radio" name="variation_<?php echo esc_html( strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>" <?php echo esc_html( $is_selected ); ?> value="<?php echo esc_attr( $value["variation_attribute"] ); ?>">
                        <span class="checkmark" style="border-color: <?php echo esc_attr( $value["variation_color"] ); ?>; background-color: <?php echo esc_attr( $value["variation_color"] ); ?>"></span>
                    </label>

                <?php $counter++; endforeach; ?>

            <?php $counter = 0; endif; ?>

        </div>
    </div>

