<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the select variation type.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/product
 */

$counter = 0;
?>

    <div class="variation-column"><h5><?php echo esc_html( $variation["variation_name"] ); ?></h5>
        <div class="checkout_field_select">

            <?php if (isset($variation['variation_primary']) && $variation['variation_primary'][0] === 'on') : ?>

                <select id="variation_<?php echo esc_html( strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>" class="checkout_select variation-price-change" name="variation_<?php echo esc_html( strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>">

                    <?php foreach ($variation["values"] as $key => $value) {

                        if ($counter == 0) {
                            $is_selected = 'selected';
                            $product_price = North_Checkout_Admin::convert_code(North_Checkout_Admin::get_current_currency()) . '<span class="value">' . number_format($value["variation_price"], 2) . '</span>';
                        } else {
                            $is_selected = '';
                        } ?>

                        <option value="<?php echo esc_attr( $value["variation_attribute"] ); ?>" data-module-num="<?php echo esc_attr( $current_module ); ?>" data-price="<?php echo esc_attr( $value["variation_price"] ); ?>" <?php echo esc_html( $is_selected ); ?>><?php echo esc_html( $value["variation_attribute"] );?> - <?php echo esc_html( North_Checkout_Admin::convert_code(North_Checkout_Admin::get_current_currency()) ); ?><span><?php echo esc_html( $value["variation_price"] ); ?></span></option>

                        <?php
                        $counter++;
                    } ?>

                </select>
            <?php $counter = 0; else:; ?>

                <select id="variation_<?php echo esc_html( strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>" class="checkout_select" name="variation_<?php echo esc_html( strtolower(str_replace(" ","_", $variation["variation_name"] ) . '_' . $current_module) ); ?>">

                    <?php foreach ($variation["values"] as $key => $value) : $is_selected = $counter == 0 ? 'selected' : ''; ?>

                        <option value="<?php echo esc_attr( $value["variation_attribute"] ); ?>" <?php echo esc_html( $is_selected ); ?>><?php echo esc_html( $value["variation_attribute"] ); ?></option>

                    <?php $counter++; endforeach; ?>

                </select>

            <?php $counter = 0; endif; ?>

        </div>
    </div>

