<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/admin/templates/tabs
 */

$no_data = true;
$args = array(
    'post_type' => 'north_product',
    'order' => 'DESC',
    'orderby' => 'meta_value',
    'meta_key' => 'sale_counter',
    'posts_per_page' => 5
);

$top_products = new WP_Query($args);

$orders_total = North_Checkout_Order::get_total_revenue();
$completed_orders = North_Checkout_Order::get_completed_orders();

?>
<div class="wrap north-settings">

    <div class="north-tab-wrapper">
        <?php $this->plugin_tabs(); ?>
    </div>

    <?php do_action( 'north_checkout_notices' ); ?>

    <div id="wpmdb-main">

        <div id="overview-tab" class="overview-tab content-tab">
            <div class="overview-wrap">
                <?php if( !empty($orders_total) ) : $no_data = false;?>
                    <div id="orders_total" class="overview-block">
                        <h4>Summary</h4>
                        <hr>
                        <p>Order revenue: $<?php echo number_format($orders_total, 2, '.', ','); ?></p>
                        <p>Completed orders: <?php echo number_format($completed_orders, null,null, ','); ?></p>
                    </div>
                <?php endif; ?>

                <?php if( $top_products->have_posts() ) : $i = 1; $no_data = false; ?>
                    <div id="top_products" class="overview-block top_products">
                        <h4>Top Products</h4>
                        <hr>
                        <?php while( $top_products->have_posts() ) : $top_products->the_post(); ?>
                            <p><?php echo esc_html( $i ) . '. ' . esc_html( get_the_title() ); ?></p>
                            <?php $i++; endwhile; ?>
                    </div>
                <?php endif; ?>
            </div>

            <?php if( $no_data ) : ?>

                <div class="no-data">
                    <h1>Looks like we don't have enough data yet.</h1>
                    <lottie-player src="<?php echo esc_url( plugin_dir_url(__FILE__) ) . '../../js/growth_animation.json'; ?>"  background="transparent"  speed="1"  style="width: 500px; height: 500px;"  loop autoplay></lottie-player>
                </div>

            <?php endif; ?>
        </div>

    </div>

</div> <!-- end .wrap -->
