<?php

/**
 * Fired during plugin activation
 *
 * @link       https://northplugins.com/
 * @since       1.0
 *
 * @package    North_Checkout
 * @subpackage North_Checkout/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since       1.0
 * @package    North_Checkout
 * @subpackage North_Checkout/includes
 * @author     North Plugins <hello@northcheckout.com>
 */
class North_Checkout_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0
	 */
	public static function activate() {
        $token = openssl_random_pseudo_bytes(16);
        $token = bin2hex($token);

        update_option( 'stripe_token', $token);
	}

}
