<?php

class North_Checkout_Form extends ET_Builder_Module {

    function init() {
        //parent::init();

        $this->name            = esc_html__( 'North Checkout', 'et_builder' );
        $this->plural          = esc_html__( 'North Checkout', 'et_builder' );
        $this->slug            = 'north_checkout';
        $this->vb_support      = 'on';
        $this->icon            = 'p';
        $this->child_slug      = 'checkout_field';
        $this->child_item_text = esc_html__( 'Block', 'et_builder' );

        $this->main_css_element = '%%order_class%%.north_checkout';

        $this->settings_modal_toggles = array(
            'general'  => array(
                'toggles' => array(
                    'main_content' => esc_html__( 'Text', 'et_builder' ),
                ),
            ),
        );

        $this->advanced_fields = array(
            'borders'               => array(
                'default' => array(
                    'css'          => array(
                        'main'      => array(
                            'border_radii'  => sprintf( '%1$s', $this->main_css_element ),
                            'border_styles' => sprintf( '%1$s', $this->main_css_element ),
                        ),
                        'important' => 'plugin_only',
                    ),
                    'label_prefix' => esc_html__( 'Inputs', 'et_builder' ),
                ),
            ),
            'fonts' => array(
                'title' => array(
                    'label'    => esc_html__( 'Title', 'et_builder' ),
                    'css'      => array(
                        'main' => "{$this->main_css_element} h1, {$this->main_css_element} h2.checkout_main_title, {$this->main_css_element} h3.checkout_main_title, {$this->main_css_element} h4.checkout_main_title, {$this->main_css_element} h5.checkout_main_title, {$this->main_css_element} h6.checkout_main_title",
                    ),
                    "line_height" => array("default" => floatval( et_get_option( "body_font_height", "1.7" ) ) . "em",),
                    "font_size" => array("default" => absint( et_get_option( "body_font_size", "14" ) ) . "px",),
                    'header_level' => array(
                        'default' => 'h1',
                    ),
                ),
            ),
            'box_shadow'            => array(
                'default' => array(
                    'css' => array(
                        'main' => implode( ', ', array(
                            '%%order_class%%',
                        ) ),
                    ),
                ),
            ),
            'button'                => array(
                'button' => array(
                    'label' => esc_html__( 'Button', 'et_builder' ),
                    'css' => array(
                        'main'         => "{$this->main_css_element}.et_pb_module .et_pb_button.checkout_submit",
                        'limited_main' => "{$this->main_css_element}.et_pb_module .et_pb_button.checkout_submit",
                    ),
                    'no_rel_attr' => true,
                    'box_shadow'  => array(
                        'css' => array(
                            'main' => '%%order_class%% .checkout_submit',
                        ),
                    ),
                    'margin_padding' => array(
                        'css' => array(
                            'important' => 'all',
                        ),
                    ),
                ),
            ),
            'margin_padding' => array(
                'margin_padding' => array(
                    'css'        => array(
                        'padding' => $this->main_css_element,
                        'margin'  => $this->main_css_element,
                    ),
                ),
            ),
            'max_width'             => array(
                'css' => array(
                    'module_alignment' => '%%order_class%%.et_pb_module',
                ),
            ),
            'text'                  => array(
                'css' => array(
                    'text_orientation' => '%%order_class%% input, %%order_class%% textarea, %%order_class%% label',
                    'text_shadow'      => '%%order_class%%, %%order_class%% input, %%order_class%% textarea, %%order_class%% label, %%order_class%% select',
                ),
            ),
            'form_field'           => array(
                'form_field' => array(
                    'label'         => esc_html__( 'Blocks', 'et_builder' ),
                    'css'           => array(
                        'main'                   => '%%order_class%% .input, %%order_class%% .checkout_product',
                        'background_color'       => '%%order_class%%  .checkout_product, %%order_class%% .input, %%order_class%% .input[type="checkbox"] + label i, %%order_class%% .input[type="radio"] + label i',
                        'background_color_hover' => '%%order_class%% .input:hover, %%order_class%% .input[type="checkbox"]:hover + label i, %%order_class%% .input[type="radio"]:hover + label i',
                        'focus_background_color' => '%%order_class%% .input:focus, %%order_class%% .input[type="checkbox"]:active + label i, %%order_class%% .input[type="radio"]:active + label i',
                        'focus_background_color_hover' => '%%order_class%% .input:focus:hover, %%order_class%% .input[type="checkbox"]:active:hover + label i, %%order_class%% .input[type="radio"]:active:hover + label i',
                        'placeholder_focus'      => '%%order_class%% p .input:focus::-webkit-input-placeholder, %%order_class%% p .input:focus::-moz-placeholder, %%order_class%% p .input:focus:-ms-input-placeholder, %%order_class%% p textarea:focus::-webkit-input-placeholder, %%order_class%% p textarea:focus::-moz-placeholder, %%order_class%% p textarea:focus:-ms-input-placeholder',
                        'padding'                => '%%order_class%% .checkout_field .input, %%order_class%% .checkout_field .checkout_product',
                        'margin'                 => '%%order_class%% .checkout_field',
                        'form_text_color'        => '%%order_class%% .checkout_field .checkout_product h4, %%order_class%% .checkout_field .checkout_product .price, %%order_class%% .input, %%order_class%% .input[type="checkbox"] + label, %%order_class%% .input[type="radio"] + label, %%order_class%% .input[type="checkbox"]:checked + label i:before',
                        'form_text_color_hover'  => '%%order_class%% .checkout_field .checkout_product:hover h4, %%order_class%% .checkout_field .checkout_product:hover .price, %%order_class%% .input:hover, %%order_class%% .input[type="checkbox"]:hover + label, %%order_class%% .input[type="radio"]:hover + label, %%order_class%% .input[type="checkbox"]:checked:hover + label i:before',
                        'focus_text_color'       => '%%order_class%% .input:focus, %%order_class%% .input[type="checkbox"]:active + label, %%order_class%% .input[type="radio"]:active + label, %%order_class%% .input[type="checkbox"]:checked:active + label i:before',
                        'focus_text_color_hover' => '%%order_class%% .input:focus:hover, %%order_class%% .input[type="checkbox"]:active:hover + label, %%order_class%% .input[type="radio"]:active:hover + label, %%order_class%% .input[type="checkbox"]:checked:active:hover + label i:before',
                    ),
                    'box_shadow'    => false,
                    'border_styles' => false,
                    'font_field'    => array(
                        'css' => array(
                            'main'  => implode( ', ', array(
                                "{$this->main_css_element} .input",
                                "{$this->main_css_element} .checkout_product",
                                "{$this->main_css_element} .input::placeholder",
                                "{$this->main_css_element} .input::-webkit-input-placeholder",
                                "{$this->main_css_element} .input::-moz-placeholder",
                                "{$this->main_css_element} .input:-ms-input-placeholder",
                                "{$this->main_css_element} .input[type=checkbox] + label",
                                "{$this->main_css_element} .input[type=radio] + label",
                            ) ),
                            'hover' => array(
                                "{$this->main_css_element} .input:hover",
                                "{$this->main_css_element} .checkout_product:hover",
                                "{$this->main_css_element} .input:hover::placeholder",
                                "{$this->main_css_element} .input:hover::-webkit-input-placeholder",
                                "{$this->main_css_element} .input:hover::-moz-placeholder",
                                "{$this->main_css_element} .input:hover:-ms-input-placeholder",
                                "{$this->main_css_element} .input[type=checkbox]:hover + label",
                                "{$this->main_css_element} .input[type=radio]:hover + label",
                            ),
                        ),
                        'line_height' => array(
                            'default' => floatval( et_get_option( "body_font_height", "1.7" ) ) . "em",
                            'default_on_child' => true
                            ),
                        'font_size' => array(
                            'default' => absint( et_get_option( "body_font_size", "14" ) ) . "px",
                            'default_on_child' => true
                            ),
                    ),
                    'margin_padding' => array(
                        'css'        => array(
                            'main'    => '%%order_class%% .input, %%order_class%% .checkout_product',
                            'padding' => '%%order_class%% .checkout_field .input, %%order_class%% .checkout_field .checkout_product',
                            'margin'  => '%%order_class%% .checkout_field',
                        ),
                    ),
                ),
                'variations' => array(
                    'label'          => esc_html__( 'Variations', 'et_builder' ),
                    'css'            => array(
                        'main' => '%%order_class%%.checkout_field .variation-container .checkmark',
                        'background_color'             => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                        'background_color_hover'       => '%%order_class%%.checkout_field .variation-container .checkmark:hover, %%order_class%%.checkout_field .variation-column select:hover',
                        'focus_background_color'       => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark',
                        'focus_background_color_hover' => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark:hover',
                        'form_text_color'              => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                        'form_text_color_hover'        => '%%order_class%%.checkout_field .variation-container .checkmark:hover',
                        'focus_text_color'             => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark',
                        'focus_text_color_hover'       => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark:hover',
                    ),
                    'margin_padding' => array(
                        'css' => array(
                            'padding'   => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                            'margin' => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                        ),
                    ),
                    'box_shadow'     => false,
                    'border_styles'  => array(
                        'variations'       => array(
                            'name'         => 'fields',
                            'css'          => array(
                                'main' => array(
                                    'border_radii'  => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                                    'border_styles' => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                                ),
                                'important' => 'all',
                            ),
                            'label_prefix' => esc_html__( 'Variations', 'et_builder' ),
                        ),
                        'variations_focus' => array(
                            'name'         => 'fields_focus',
                            'css'          => array(
                                'main' => array(
                                    'border_radii'  => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark, %%order_class%%.checkout_field .variation-container input:checked~.checkmark:after',
                                    'border_styles' => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark, %%order_class%%.checkout_field .variation-container input:checked~.checkmark:after',
                                ),
                                'important' => 'all',
                            ),
                            'label_prefix' => esc_html__( 'Variations Focus', 'et_builder' ),
                        ),
                    ),
                    'font_field'     => array(
                        'css' => array(
                            'main'      => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                            'important' => 'plugin_only',
                        ),
                        'line_height' => array(
                            'default' => floatval( et_get_option( "body_font_height", "1.7" ) ) . "em",
                            'default_on_child' => true
                        ),
                        'font_size' => array(
                            'default' => absint( et_get_option( "body_font_size", "14" ) ) . "px",
                            'default_on_child' => true
                        ),
                    ),
                ),
                'bump' => array(
                    'label'          => esc_html__( 'Bump', 'et_builder' ),
                    'css'            => array(
                        'main' => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                        'background_color'             => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                        'hover_background_color'       => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label:hover i',
                        'focus_background_color'       => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                        'focus_background_color_hover' => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label:hover i',
                        'form_text_color'              => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i:before',
                        'form_text_color_hover'        => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label:hover i:before',
                        'focus_text_color'             => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label i:before',
                        'focus_text_color_hover'       => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label:hover i:before',
                    ),
                    'margin_padding' => array(
                        'css' => array(
                            'padding'   => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                            'margin' => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                        ),
                    ),
                    'box_shadow'     => false,
                    'border_styles' => array(
                        'bump'       => array(
                            'name'         => 'bump',
                            'css'          => array(
                                'main' => array(
                                    'border_radii'  => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                                    'border_styles' => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]+label i',
                                ),
                                'important' => 'all',
                            ),
                            'label_prefix' => esc_html__( 'Bump', 'et_builder' ),
                        ),
                        'bump_focus' => array(
                            'name'         => 'bump_focus',
                            'css'          => array(
                                'main' => array(
                                    'border_radii'  => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                                    'border_styles' => '%%order_class%% .checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                                ),
                                'important' => 'all',
                            ),
                            'label_prefix' => esc_html__( 'Bump Focus', 'et_builder' ),
                        ),
                    ),
                    'font_field'      => array(
                        'css'              => array(
                            'main'      => array(
                                '.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i:before',
                            ),
                        ),
                        'font_size'        => array(
                            'default' => absint( et_get_option( "body_font_size", "17" ) ) . "px",
                            'default_on_child' => true
                        ),
                        'line_height'        => array(
                            'default' => absint( et_get_option( "body_font_height", "17" ) ) . "px",
                            'default_on_child' => true
                        ),
                        'hide_font' => true,
                        'hide_text_align'  => true,
                        'hide_text_shadow'  => true,
                        'hide_letter_spacing'  => true,
                    ),
                ),
            ),
        );

        $this->custom_css_fields = array(
            'checkout_title' => array(
                'label'    => esc_html__( 'Contact Title', 'et_builder' ),
                'selector' => '.checkout_main_title',
            ),
            'checkout_button' => array(
                'label'    => esc_html__( 'Contact Button', 'et_builder' ),
                'selector' => '%%order_class%% .et_checkout_bottom_container .checkout_submit.button',
                'no_space_before_selector' => true,
            ),
            'checkout_fields' => array(
                'label'    => esc_html__( 'Form Fields', 'et_builder' ),
                'selector' => 'input',
            ),
            'text_field' => array(
                'label'    => esc_html__( 'Message Field', 'et_builder' ),
                'selector' => 'textarea.checkout_message',
            ),
            'captcha_field' => array(
                'label'    => esc_html__( 'Captcha Field', 'et_builder' ),
                'selector' => 'input.checkout_captcha',
            ),
            'captcha_label' => array(
                'label'    => esc_html__( 'Captcha Text', 'et_builder' ),
                'selector' => '.checkout_right p',
            ),
        );

        $this->help_videos = array(
            array(
                'id'   => esc_html( 'y3NSTE6BSfo' ),
                'name' => esc_html__( 'An introduction to the Contact Form module', 'et_builder' ),
            ),
        );
    }

    /**
     * Get form map containing essential info (form number, field id/type/required) based on
     * checkout_field's shortcode layout
     *
     * @since 3.26.5
     *
     * @param string $content_shortcode
     * @param int    $north_checkout_number
     * @param array  $hidden_form_fields
     *
     * @return mixed[] {
     *     Form Map
     *
     *     @type int      $form_number Contact form number.
     *     @type string[] $fields      {
     *         Form Field
     *
     *         @type string $field_type    Field type
     *         @type string $field_id      Field id
     *         @type string $required_mark Required field status. Accepts 'on', 'off'.
     *     }
     * }
     */
    function get_form_map( $content_shortcode = '', $north_checkout_number = 0, $hidden_form_fields = array() ) {
        $pattern = get_shortcode_regex( array( 'checkout_field' ) );
        $map     = array(
            'form_number' => (int) $north_checkout_number,
            'fields'      => array(),
        );

        preg_match_all( "/$pattern/", $content_shortcode, $checkout_fields, PREG_SET_ORDER );

        foreach( $checkout_fields as $checkout_field ) {
            $checkout_field_attrs = shortcode_parse_atts( $checkout_field[3] );
            $field_id            = strtolower( self::$_->array_get( $checkout_field_attrs, 'field_id' ) );
            $conditional_logic   = self::$_->array_get( $checkout_field_attrs, 'conditional_logic', 'off' );

            // Only allow to disable fields for which conditional logic has been enabled
            if ( 'on' === $conditional_logic && in_array( $field_id, $hidden_form_fields ) ) {
                continue;
            }

            $map['fields'][] = array(
                'field_type'    => self::$_->array_get( $checkout_field_attrs, 'field_type', 'input' ),
                'field_id'      => $field_id,
                'required_mark' => self::$_->array_get( $checkout_field_attrs, 'required_mark', 'on' ),
            );
        }

        return $map;
    }

    function get_fields() {

        return array(
                'title'              => array(
                    'label'           => esc_html__( 'Title', 'et_builder' ),
                    'type'            => 'text',
                    'option_category' => 'basic_option',
                    'description'     => esc_html__( 'Define a title for your checkout form.', 'et_builder' ),
                    'toggle_slug'     => 'main_content',
                    'dynamic_content' => 'text',
                    'mobile_options'  => true,
                    'hover'           => 'tabs',
                ),
                'use_redirect'       => array(
                    'label'            => esc_html__( 'Enable Redirect URL', 'et_builder' ),
                    'type'             => 'yes_no_button',
                    'option_category'  => 'configuration',
                    'options'          => array(
                        'off' => esc_html__( 'No', 'et_builder' ),
                        'on'  => esc_html__( 'Yes', 'et_builder' ),
                    ),
                    'affects'          => array(
                        'redirect_url',
                    ),
                    'toggle_slug'      => 'redirect',
                    'description'      => esc_html__( 'Redirect users after successful form submission.', 'et_builder' ),
                    'default_on_front' => 'off',
                ),
                'redirect_url'       => array(
                    'label'           => esc_html__( 'Redirect URL', 'et_builder' ),
                    'type'            => 'text',
                    'option_category' => 'configuration',
                    'depends_show_if' => 'on',
                    'toggle_slug'     => 'redirect',
                    'description'     => esc_html__( 'Type the Redirect URL', 'et_builder' ),
                ),
                'success_message'    => array(
                    'label'           => esc_html__( 'Success Message', 'et_builder' ),
                    'type'            => 'text',
                    'option_category' => 'configuration',
                    'description'     => esc_html__( 'Type the message you want to display after successful form submission. Leave blank for default', 'et_builder' ),
                    'toggle_slug'     => 'main_content',
                    'dynamic_content' => 'text',
                ),
                'submit_button_text' => array(
                    'label'           => esc_html__( 'Submit Button', 'et_builder' ),
                    'type'            => 'text',
                    'option_category' => 'basic_option',
                    'description'     => esc_html__( 'Define the text of the form submit button.', 'et_builder' ),
                    'toggle_slug'     => 'main_content',
                    'dynamic_content' => 'text',
                    'mobile_options'  => true,
                    'hover'           => 'tabs',
                    'default'         => 'Checkout',
                ),
            );
    }

    public function get_transition_fields_css_props() {
        $fields = parent::get_transition_fields_css_props();

        $fields['form_field_background_color'] = array(
            'background-color' => implode(', ', array(
                '%%order_class%% .input',
                '%%order_class%% .input[type="checkbox"]+label i',
                '%%order_class%% .input[type="radio"]+label i',
            ))
        );

        return $fields;
    }

    function predefined_child_modules() {
        $output = sprintf(
            '[checkout_field field_title="%1$s" field_type="input" field_id="Name" required_mark="on" fullwidth_field="off" /][checkout_field field_title="%2$s" field_type="email" field_id="Email" required_mark="on" fullwidth_field="off" /][checkout_field field_title="%3$s" field_type="text" field_id="Message" required_mark="on" fullwidth_field="on" /]',
            esc_attr__( 'Name', 'et_builder' ),
            esc_attr__( 'Email Address', 'et_builder' ),
            esc_attr__( 'Message', 'et_builder' )
        );

        return $output;
    }

//    public function get_advanced_fields_config() {
//        return array(
//            "background" => array("use_background_image" => true, "use_background_video" => true,),
//            "text" => array(),
//            "borders" => array(),
//            "box_shadow" => array(),
//            "button" => array(),
//            "filters" => array(),
//            "fonts" => array(
//                "text_field" => array(
//                    "label" =>  __("Text Field", "dp_dmb"),
//                    "css" => array("main" => "{$this->main_css_element} .dp_field_text_field", ),
//                    "line_height" => array("default" => floatval( et_get_option( "body_font_height", "1.7" ) ) . "em",),
//                    "font_size" => array("default" => absint( et_get_option( "body_font_size", "14" ) ) . "px",),
//                ),
//                "textarea_field" => array(
//                    "label" =>  __("Textarea Field", "dp_dmb"),
//                    "css" => array("main" => "{$this->main_css_element} .dp_field_textarea_field", ),
//                    "line_height" => array("default" => floatval( et_get_option( "body_font_height", "1.7" ) ) . "em",),
//                    "font_size" => array("default" => absint( et_get_option( "body_font_size", "14" ) ) . "px",),
//                ),),
//            "margin_padding" => array(),
//            "max_width" => array(),
//            "animation" => array()
//        );
//    }

    function render( $attrs, $content = null, $render_slug ) {

        global $half_width_counter, $north_checkout_num;

        $half_width_counter = 0;

        $multi_view = et_pb_multi_view_options( $this );
        $multi_view->set_default_value( 'submit_button_text', __( 'Checkout', 'et_builder' ) );

        $title                       = $multi_view->render_element( array(
            'tag'     => et_pb_process_header_level( $this->props['title_level'], 'h1' ),
            'content' => '{{title}}',
            'attrs'   => array(
                'class' => 'north_checkout_title',
            ),
        ) );
        $form_field_text_color       = $this->props['form_field_text_color'];
        $button_custom               = $this->props['custom_button'];
        $use_redirect                = $this->props['use_redirect'];
        $redirect_url                = $this->props['redirect_url'];
        $success_message             = $this->_esc_attr( 'success_message' );
        $header_level                = $this->props['title_level'];

        $field_text_color_hover        = $this->get_hover_value( 'form_field_text_color' );
        $field_text_color_values       = et_pb_responsive_options()->get_property_values( $this->props, 'form_field_text_color' );
        $field_focus_text_color_hover  = $this->get_hover_value( 'form_field_focus_text_color' );
        $field_focus_text_color_values = et_pb_responsive_options()->get_property_values( $this->props, 'form_field_focus_text_color' );

        $custom_icon_values          = et_pb_responsive_options()->get_property_values( $this->props, 'button_icon' );
        $custom_icon                 = isset( $custom_icon_values['desktop'] ) ? $custom_icon_values['desktop'] : '';
        $custom_icon_tablet          = isset( $custom_icon_values['tablet'] ) ? $custom_icon_values['tablet'] : '';
        $custom_icon_phone           = isset( $custom_icon_values['phone'] ) ? $custom_icon_values['phone'] : '';

        $video_background          = $this->video_background();
        $parallax_image_background = $this->get_parallax_image_background();

        // Form Field Text Color - Radio Checked.
        $field_text_color_important = et_builder_has_limitation( 'force_use_global_important' ) ? ' !important' : '';
        et_pb_responsive_options()->generate_responsive_css( $field_text_color_values, '%%order_class%% .input[type="radio"]:checked + label i:before', 'background-color', $render_slug, $field_text_color_important, 'color' );

        if ( et_builder_is_hover_enabled( 'form_field_text_color', $this->props ) ) {
            ET_Builder_Element::set_style( $render_slug, array(
                'selector'    => '%%order_class%% .input[type="radio"]:checked:hover + label i:before',
                'declaration' => sprintf(
                    'background-color: %1$s%2$s;',
                    esc_html( $field_text_color_hover ),
                    $field_text_color_important
                ),
            ) );
        }

        // Form Field Text Color on Focus - Radio Checked.
        et_pb_responsive_options()->generate_responsive_css( $field_focus_text_color_values, '%%order_class%% .input[type="radio"]:checked:active + label i:before', 'background-color', $render_slug, $field_text_color_important, 'color' );

        if ( et_builder_is_hover_enabled( 'form_field_focus_text_color', $this->props ) ) {
            ET_Builder_Element::set_style( $render_slug, array(
                'selector'    => '%%order_class%% .input[type="radio"]:checked:active:hover + label i:before',
                'declaration' => sprintf(
                    'background-color: %1$s%2$s;',
                    esc_html( $field_focus_text_color_hover ),
                    $field_text_color_important
                ),
            ) );
        }

        $success_message = '' !== $success_message ? $success_message : esc_html__( 'Thanks for checkouting us', 'et_builder' );

        $north_checkout_num  = $this->render_count();
        $hidden_form_fields_key  = "checkout_email_hidden_fields_{$north_checkout_num}";
        $hidden_form_fields      = self::$_->array_get( $_POST, $hidden_form_fields_key, array() ); // phpcs:ignore WordPress.Security.NonceVerification.Missing
        $shortcode_content       = $content;

        if ( ! empty( $hidden_form_fields ) ) {
            $hidden_form_fields = str_replace( '\\', '', $hidden_form_fields );
            $hidden_form_fields = json_decode( $hidden_form_fields );
        }

        $content = $this->content;

        $et_error_message = '';
        $et_checkout_error = false;
        $current_form_fields = isset( $_POST['checkout_email_fields_' . $north_checkout_num] ) ? sanitize_text_field($_POST['checkout_email_fields_' . $north_checkout_num]) : ''; // phpcs:ignore WordPress.Security.NonceVerification.Missing
        $checkout_email = '';
        $processed_fields_values = array();

        $nonce_result = isset( $_POST['_wpnonce-et-pb-north-checkout-submitted-' . $north_checkout_num] ) && wp_verify_nonce( sanitize_text_field($_POST['_wpnonce-et-pb-north-checkout-submitted-' . $north_checkout_num], 'et-pb-north-checkout-submit' )) ? true : false;

        // check that the form was submitted and checkout_et_number field is empty to protect from spam
        if ( $nonce_result && isset( $_POST['checkoutform_submit_' . $north_checkout_num] ) && empty( $_POST['checkout_et_number_' . $north_checkout_num] ) ) {
            if ( '' !== $current_form_fields ) {
                $fields_data_json = str_replace( '\\', '' ,  $current_form_fields );
                $fields_data_array = json_decode( $fields_data_json, true );

                // check all fields on current form and generate error message if needed
                if ( ! empty( $fields_data_array ) ) {

                    // Generate form map of submitted form
                    $submitted_form_map = array(
                        'form_number' => $north_checkout_num,
                        'fields'      => array(),
                    );

                    foreach( $fields_data_array as $index => $value ) {
                        if ( isset( $value['field_id'] ) && 'checkout_et_number_' . $north_checkout_num === $value['field_id'] ) {
                            continue;
                        }

                        // Populate form map's fields
                        $submitted_form_map['fields'][] = array(
                            'field_type'    => self::$_->array_get( $value, 'field_type', 'input' ),
                            'field_id'      => self::$_->array_get( $value, 'original_id' ),
                            'required_mark' => 'required' === self::$_->array_get( $value, 'required_mark', 'required' ) ? 'on' : 'off',
                        );

                        // check all the required fields, generate error message if required field is empty
                        $field_value = isset( $_POST[ $value['field_id'] ] ) ? trim( sanitize_text_field( $_POST[ $value['field_id'] ] ) ) : '';

                        if ( 'required' === $value['required_mark'] && empty( $field_value ) && ! is_numeric( $field_value ) ) {
                            $et_error_message .= sprintf( '<p class="checkout_error_text">%1$s</p>', esc_html__( 'Make sure you fill in all required fields.', 'et_builder' ) );
                            $et_checkout_error = true;
                            continue;
                        }

                        // additional check for email field
                        if ( 'email' === $value['field_type'] && 'required' === $value['required_mark'] && ! empty( $field_value ) ) {
                            $checkout_email = isset( $_POST[ $value['field_id'] ] ) ? sanitize_email( $_POST[ $value['field_id'] ] ) : '';

                            if ( ! empty( $checkout_email ) && ! is_email( $checkout_email ) ) {
                                $et_error_message .= sprintf( '<p class="checkout_error_text">%1$s</p>', esc_html__( 'Invalid Email.', 'et_builder' ) );
                                $et_checkout_error = true;
                            }
                        }

                        // prepare the array of processed field values in convenient format
                        if ( false === $et_checkout_error ) {
                            $processed_fields_values[ $value['original_id'] ]['value'] = $field_value;
                            $processed_fields_values[ $value['original_id'] ]['label'] = $value['field_label'];
                        }
                    }

                    // Check form's integrity by comparing fields structure (used for required fields check, etc)
                    // stored in the shortcode against submitted value generated using JS on the front end
                    // to prevent data being altered by modifying form markup.
                    $form_map = $this->get_form_map( $shortcode_content, $north_checkout_num, $hidden_form_fields );

                    if ( serialize( $submitted_form_map ) !== serialize( $form_map ) ) {
                        $et_error_message .= sprintf(
                            '<p class="checkout_error_text">%1$s</p>',
                            esc_html__( 'Invalid submission. Please refresh the page and try again.', 'et_builder' )
                        );
                        $et_checkout_error = true;
                    }
                }
            } else {
                $et_error_message .= sprintf( '<p class="checkout_error_text">%1$s</p>', esc_html__( 'Make sure you fill in all required fields.', 'et_builder' ) );
                $et_checkout_error = true;
            }
        } else {
            if ( false === $nonce_result && isset( $_POST['checkoutform_submit_' . $north_checkout_num] ) && empty( $_POST['checkout_et_number_' . $north_checkout_num] ) ) {
                $et_error_message .= sprintf( '<p class="checkout_error_text">%1$s</p>', esc_html__( 'Please refresh the page and try again.', 'et_builder' ) );
            }
            $et_checkout_error = true;
        }

        // generate digits for captcha
        $first_digit = rand( 1, 15 );
        $second_digit = rand( 1, 15 );

//        if ( ! $et_checkout_error && $nonce_result ) {
//            $et_email_to = '' !== $email
//                ? $email
//                : get_site_option( 'admin_email' );
//
//            $et_site_name = get_option( 'blogname' );
//
//            $checkout_name = isset( $processed_fields_values['name'] ) ? stripslashes( sanitize_text_field( $processed_fields_values['name']['value'] ) ) : '';
//
//            if ( '' !== $custom_message ) {
//                // decode html entites to make sure HTML from the message pattern is rendered properly
//                $message_pattern = et_builder_convert_line_breaks( html_entity_decode( $custom_message ), "\r\n" );
//
//                // insert the data from checkout form into the message pattern
//                foreach ( $processed_fields_values as $key => $value ) {
//                    // strip all tags from each field. Don't strip tags from the entire message to allow using HTML in the pattern.
//                    $message_pattern = str_ireplace( "%%{$key}%%", wp_strip_all_tags( $value['value'] ), $message_pattern );
//                }
//
//                if ( is_array( $hidden_form_fields ) ) {
//                    foreach ( $hidden_form_fields as $hidden_field_label ) {
//                        $message_pattern = str_ireplace( "%%{$hidden_field_label}%%", '', $message_pattern );
//                    }
//                }
//            } else {
//                // use default message pattern if custom pattern is not defined
//                $message_pattern = isset( $processed_fields_values['message']['value'] ) ? $processed_fields_values['message']['value'] : '';
//
//                // Add all custom fields into the message body by default
//                foreach ( $processed_fields_values as $key => $value ) {
//                    if ( ! in_array( $key, array( 'message', 'name', 'email' ) ) ) {
//                        $message_pattern .= "\r\n";
//                        $message_pattern .= sprintf(
//                            '%1$s: %2$s',
//                            '' !== $value['label'] ? $value['label'] : $key,
//                            $value['value']
//                        );
//                    }
//                }
//
//                // strip all tags from the message content
//                $message_pattern = wp_strip_all_tags( $message_pattern );
//            }
//
//            $http_host = str_replace( 'www.', '', $_SERVER['HTTP_HOST'] );
//
//            $headers[] = "From: \"{$checkout_name}\" <mail@{$http_host}>";
//
//            // Set `Reply-To` email header based on checkout_name and checkout_email values
//            if ( ! empty( $checkout_email ) ) {
//                $checkout_name = ! empty( $checkout_name ) ? $checkout_name : $checkout_email;
//                $headers[] = "Reply-To: \"{$checkout_name}\" <{$checkout_email}>";
//            }
//
//            add_filter( 'et_get_safe_localization', 'et_allow_ampersand' );
//
//            // don't strip tags at this point to properly send the HTML from pattern. All the unwanted HTML stripped at this point.
//            $email_message = trim( stripslashes( $message_pattern ) );
//
//            wp_mail( apply_filters( 'et_checkout_page_email_to', $et_email_to ),
//                et_get_safe_localization( sprintf(
//                    __( 'New Message From %1$s%2$s', 'et_builder' ),
//                    sanitize_text_field( html_entity_decode( $et_site_name, ENT_QUOTES, 'UTF-8' ) ),
//                    ( '' !== $title ? sprintf( _x( ' - %s', 'checkout form title separator', 'et_builder' ), $title ) : '' )
//                ) ),
//                ! empty( $email_message ) ? $email_message : ' ',
//                apply_filters( 'et_checkout_page_headers', $headers, $checkout_name, $checkout_email )
//            );
//
//            remove_filter( 'et_get_safe_localization', 'et_allow_ampersand' );
//
//            $et_error_message = sprintf( '<p>%1$s</p>', et_core_esc_previously( $success_message ) );
//        }

        $form = '';

        if ( '' === trim( $content ) ) {
            $content = do_shortcode( $this->predefined_child_modules() );
        }

        if ( $et_checkout_error ) {
            $multi_view_data_attr = $multi_view->render_attrs( array(
                'content' => '{{submit_button_text}}',
            ) );

            $form = sprintf( '
				<div class="checkout">
				    %11$s
					<form id="payment-form" class="clearfix" method="post" data-redirect="%10$s">
						%6$s
						<input type="hidden" value="et_checkout_proccess" name="checkout_form_submit_%5$s"/>
						<input type="hidden" id="product_module" value="" name="product_module"/>
						<div class="et_checkout_bottom_container">
							<button type="submit" name="et_builder_submit_button" class="checkout_submit et_pb_button %4$s"%3$s%7$s%8$s%9$s><span>%1$s</span><div class="loader"></div></button>
						</div>
						%2$s
					</form>
				</div> <!-- .checkout -->',
                esc_html( $multi_view->get_value( 'submit_button_text' ) ),
                wp_nonce_field( 'et-pb-north-checkout-submit', '_wpnonce-et-pb-north-checkout-submitted-' . $north_checkout_num, true, false ),
                '' !== $custom_icon && 'on' === $button_custom ? sprintf(
                    ' data-icon="%1$s"',
                    esc_attr( et_pb_process_font_icon( $custom_icon ) )
                ) : '', // #5
                '' !== $custom_icon && 'on' === $button_custom ? ' et_pb_custom_button_icon' : '',
                esc_attr( $north_checkout_num ),
                $content,
                '' !== $custom_icon_tablet && 'on' === $button_custom ? sprintf( ' data-icon-tablet="%1$s"', esc_attr( et_pb_process_font_icon( $custom_icon_tablet ) ) ) : '',
                '' !== $custom_icon_phone && 'on' === $button_custom ? sprintf( ' data-icon-phone="%1$s"', esc_attr( et_pb_process_font_icon( $custom_icon_phone ) ) ) : '', // #10
                $multi_view_data_attr,
                $redirect_url,
                $title
            );
        }

        // Module classnames
        $this->add_classname( array(
            'north_checkout_container',
            'clearfix',
            $this->get_text_orientation_classname(),
        ) );

        // Remove automatically added classname
        //$this->remove_classname( $render_slug );

        // Contact form should always have the ID. Use saved ID or generate automatically
        $module_id = '' !== $this->module_id(false) ? $this->module_id(false) : 'north_checkout_' . $north_checkout_num;

        $output = sprintf( '
				%4$s
				%3$s
				<div id="card-errors" class="et-pb-checkout-message" role="alert">%1$s</div>
				%2$s
			',
            $et_error_message,
            $form,
            $video_background,
            $parallax_image_background
        );

        return $output;
    }

    /**
     * Filter multi view value.
     *
     * @since 3.27.1
     *
     * @see ET_Builder_Module_Helper_MultiViewOptions::filter_value
     *
     * @param mixed $raw_value Props raw value.
     * @param array $args {
     *     Context data.
     *
     *     @type string $context      Context param: content, attrs, visibility, classes.
     *     @type string $name         Module options props name.
     *     @type string $mode         Current data mode: desktop, hover, tablet, phone.
     *     @type string $attr_key     Attribute key for attrs context data. Example: src, class, etc.
     *     @type string $attr_sub_key Attribute sub key that availabe when passing attrs value as array such as styes. Example: padding-top, margin-botton, etc.
     * }
     * @param ET_Builder_Module_Helper_MultiViewOptions $multi_view Multiview object instance.
     *
     * @return mixed
     */
    public function multi_view_filter_value( $raw_value, $args, $multi_view ) {
        $name = isset( $args['name'] ) ? $args['name'] : '';
        $mode = isset( $args['mode'] ) ? $args['mode'] : '';

        $fields_need_escape = array(
            'title',
        );

        if ( $raw_value && in_array( $name, $fields_need_escape, true ) ) {
            return $this->_esc_attr( $multi_view->get_name_by_mode( $name, $mode ), 'none', $raw_value );
        } else if ( 'submit_button_text' === $name ) {
            if ( '' === trim( $raw_value ) ) {
                $raw_value = __( 'Checkout', 'et_builder' );
            }

            return esc_html( $raw_value );
        }

        return $raw_value;
    }
}

new North_Checkout_Form;

