<?php

class North_checkout_Item extends ET_Builder_Module {

    public $additional_shortcode_slugs = array( 'signup_custom_field' );

    function init() {
        $this->name            = esc_html__( 'Block', 'et_builder' );
        $this->plural          = esc_html__( 'Blocks', 'et_builder' );
        $this->slug            = 'checkout_field';
        $this->vb_support      = 'on';
        $this->type            = 'child';
        $this->child_title_var = 'field_id';
        $this->advanced_setting_title_text = esc_html__( 'New Block', 'et_builder' );
        $this->settings_text               = esc_html__( 'Block Settings', 'et_builder' );
        $this->main_css_element = '.et_pb_module.north_checkout %%order_class%%.checkout_field';

        $this->settings_modal_toggles = array(
            'general'  => array(
                'toggles' => array(
                    'main_content'     => esc_html__( 'Block Options', 'et_builder' ),
                    'conditional_logic' => esc_html__( 'Conditional Logic', 'et_builder' ),
                ),
            ),
            'advanced' => array(
                'toggles' => array(
                    'layout' => esc_html__( 'Layout', 'et_builder' ),
                ),
            ),
        );

        $this->advanced_fields = array(
            'borders'        => array(
                'default' => array(
                    'css'          => array(
                        'main'      => array(
                            'border_radii'  => sprintf( '%1$s .input, %1$s .checkout_product, %1$s .checkout_total, %1$s .input[type="checkbox"] + label i, %1$s .input[type="radio"] + label i, %1$s .checkout_order_bump', $this->main_css_element ),
                            'border_styles' => sprintf( '%1$s .input, %1$s .checkout_product, %1$s .checkout_total, %1$s .input[type="checkbox"] + label i, %1$s .input[type="radio"] + label i, %1$s .checkout_order_bump', $this->main_css_element ),
                        ),
                        'important' => 'plugin_only',
                    ),
                    'label_prefix' => esc_html__( 'Input', 'et_builder' ),
                ),
                'default_focus' => array(
                    'css'          => array(
                        'main'      => array(
                            'border_radii'  => sprintf( '%1$s .input:focus, %1$s .checkout_product.active, %1$s .checkout_total.focus, %1$s .input[type="checkbox"]:checked + label i, %1$s .input[type="radio"]:checked + label i, %1$s .checkout_order_bump.checked', $this->main_css_element ),
                            'border_styles' => sprintf( '%1$s .input:focus, %1$s .checkout_product.active, %1$s .checkout_total.focus, %1$s .input[type="checkbox"]:checked + label i, %1$s .input[type="radio"]:checked + label i, %1$s .checkout_order_bump.checked', $this->main_css_element ),
                        ),
                        'important' => 'plugin_only',
                    ),
                    'label_prefix' => esc_html__( 'Input focus', 'et_builder' ),
                ),
            ),
            'box_shadow'     => array(
                'default' => array(
                    'css' => array(
                        'main'      => implode( ', ', array(
                            '%%order_class%% input',
                            '%%order_class%% .checkout_product',
                            '%%order_class%% .checkout_total',
                            '%%order_class%%.checkout_field .checkout_order_bump',
                            '%%order_class%% select',
                            '%%order_class%% textarea',
                            '%%order_class%% .checkout_field_options_list label > i',
                        ) ),
                        'important' => true,
                    ),
                ),
            ),
            'background'     => array(
                'css' => array(
                    'main' => '%%order_class%%',
                ),
            ),
            'margin_padding' => array(
                'css' => array(
                    'padding'   => 'div%%order_class%%.checkout_field .checkout_product, div%%order_class%%.checkout_field .checkout_total, div%%order_class%%.checkout_field .input, %%order_class%%.checkout_field .checkout_order_bump',
                    'important' => array( 'custom_margin' ), // needed to overwrite last module margin-bottom styling
                ),
            ),
            'text' => array(
                'css' => array(
                    'text_orientation' => '%%order_class%% input, %%order_class%% textarea, %%order_class%% label, %%order_class%% .price_before, %%order_class%% .price_after, %%order_class%% .inventory',
                ),
            ),
            'text_shadow'    => array(
                // Don't add text-shadow fields since they already are via font-options
                'default' => false,
            ),
            'filters'        => array(
                'css' => array(
                    'main' => array(
                        '%%order_class%% input',
                        '%%order_class%% textarea',
                        '%%order_class%% label',
                        '%%order_class%% .checkout_product',
                        '%%order_class%% .checkout_total',
                        '%%order_class%%.checkout_field .checkout_order_bump',
                    ),
                ),
            ),
            'button'         => false,
            'form_field'    => array(
                'form_field' => array(
                    'label'          => esc_html__( 'Blocks', 'et_builder' ),
                    'css'            => array(
                        'main'                         => '%%order_class%%.checkout_field .input, %%order_class%%.checkout_field .checkout_product, %%order_class%%.checkout_field .checkout_order_bump, %%order_class%%.checkout_field .checkout_total',
                        'background_color'             => '%%order_class%%.checkout_field .input, %%order_class%%.checkout_field .checkout_product, %%order_class%%.checkout_field .checkout_order_bump, %%order_class%%.checkout_field .checkout_total, %%order_class%%.checkout_field .input[type="checkbox"] + label i, %%order_class%%.checkout_field .input[type="radio"] + label i',
                        'background_color_hover'       => '%%order_class%%.checkout_field .input:hover, %%order_class%%.checkout_field .input[type="checkbox"] + label:hover i,  %%order_class%%.checkout_field .input[type="radio"] + label:hover i',
                        'focus_background_color'       => '%%order_class%%.checkout_field .input:focus, %%order_class%%.checkout_field .input[type="checkbox"]:active + label i, %%order_class%%.checkout_field .checkout_order_bump.checked, %%order_class%%.checkout_field .input[type="radio"]:checked + label i, %%order_class%%.checkout_field .input[type="checkbox"]:checked + label i',
                        'focus_background_color_hover' => '%%order_class%%.checkout_field .input:focus:hover, %%order_class%%.checkout_field .input[type="checkbox"]:active:hover + label i, %%order_class%%.checkout_field .input[type="radio"]:active:hover + label i',
                        'form_text_color'              => '%%order_class%%.checkout_field .input, %%order_class%%.checkout_field .checkout_product h4, %%order_class%%.checkout_field .checkout_total h4, %%order_class%%.checkout_field .checkout_product .price, %%order_class%%.checkout_field .checkout_total .price, %%order_class%%.checkout_field .checkout_product, %%order_class%%.checkout_field .checkout_total, %%order_class%%.checkout_field .input[type="checkbox"] + label, %%order_class%%.checkout_field .input[type="radio"] + label, %%order_class%%.checkout_field .input[type="checkbox"]:checked + label i:before, %%order_class%% label, %%order_class%% .price_before, %%order_class%% .price_after, %%order_class%% .inventory',
                        'form_text_color_hover'        => '%%order_class%%.checkout_field .input:hover, %%order_class%%.checkout_field .checkout_product:hover h4, %%order_class%%.checkout_field .checkout_product:hover .price, %%order_class%%.checkout_field .input[type="checkbox"]:hover + label,
						%%order_class%%.checkout_field .input[type="radio"]:hover + label, %%order_class%%.checkout_field .input[type="checkbox"]:checked:hover + label i:before',
                        'focus_text_color'             => '%%order_class%%.checkout_field .input:focus, %%order_class%%.checkout_field .input[type="checkbox"]:active + label, %%order_class%%.checkout_field .checkout_order_bump.checked label,
						%%order_class%%.checkout_field .input[type="radio"]:checked + label, %%order_class%%.checkout_field .input[type="checkbox"]:checked + label i:before',
                        'focus_text_color_hover'       => '%%order_class%%.checkout_field .input:focus:hover, %%order_class%%.checkout_field .checkout_product:hover h4, %%order_class%%.checkout_field .checkout_product:hover .price, %%order_class%%.checkout_field .input[type="checkbox"]:active:hover + label,
						%%order_class%%.checkout_field .input[type="radio"]:active:hover + label, %%order_class%%.checkout_field .input[type="checkbox"]:checked:active:hover + label i:before',
                    ),
                    'margin_padding' => false,
                    'box_shadow'     => false,
                    'border_styles'  => false,
                    'font_field'     => array(
                        'css' => array(
                            'main'      => implode( ',', array(
                                '%%order_class%%.checkout_field .checkout_field_options_title',
                                "{$this->main_css_element} h4",
                                "{$this->main_css_element} label",
                                "{$this->main_css_element} .price_before",
                                "{$this->main_css_element} .price_after",
                                "{$this->main_css_element} .inventory",
                                "{$this->main_css_element} .price",
                                "{$this->main_css_element} .input",
                                "{$this->main_css_element} .input::placeholder",
                                "{$this->main_css_element} .input::-webkit-input-placeholder",
                                "{$this->main_css_element} .input::-moz-placeholder",
                                "{$this->main_css_element} .input:-ms-input-placeholder",
                                "{$this->main_css_element} .input[type=checkbox] + label",
                                "{$this->main_css_element} .input[type=radio] + label",
                            ) ),
                            'important' => 'plugin_only',
                        ),
                    ),
                ),
            ),
            'height' => array(
                'css' => array(
                    'main' => implode(', ', array(
                        '%%order_class%% input[type=text]',
                        '%%order_class%% input[type=email]',
                        '%%order_class%% textarea',
                        '%%order_class%%[data-type=checkbox]',
                        '%%order_class%%[data-type=radio]',
                        '%%order_class%%[data-type=select]',
                        '%%order_class%%[data-type=select] select',
                    ))
                )
            ),
        );

        $this->advanced_fields["form_field"]["variations"] = array(
            'label'          => esc_html__( 'Variations', 'et_builder' ),
            'css'            => array(
                'main' => '%%order_class%%.checkout_field .variation-container .checkmark',
                'background_color'             => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                'background_color_hover'       => '%%order_class%%.checkout_field .variation-container .checkmark:hover, %%order_class%%.checkout_field .variation-column select:hover',
                'focus_background_color'       => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark',
                'focus_background_color_hover' => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark:hover',
                'form_text_color'              => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                'form_text_color_hover'        => '%%order_class%%.checkout_field .variation-container .checkmark:hover',
                'focus_text_color'             => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark',
                'focus_text_color_hover'       => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark:hover',
            ),
            'margin_padding' => array(
                'css' => array(
                    'padding'   => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                    'margin' => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                ),
            ),
            'box_shadow'     => false,
            'border_styles' => array(
                'variations'       => array(
                    'name'         => 'fields',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                            'border_styles' => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( 'Variations', 'et_builder' ),
                ),
                'variations_focus' => array(
                    'name'         => 'fields_focus',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark, %%order_class%%.checkout_field .variation-container input:checked~.checkmark:after',
                            'border_styles' => '%%order_class%%.checkout_field .variation-container input:checked~.checkmark, %%order_class%%.checkout_field .variation-container input:checked~.checkmark:after',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( 'Variations Focus', 'et_builder' ),
                ),
            ),
            'font_field'     => array(
                'css' => array(
                    'main'      => '%%order_class%%.checkout_field .variation-container .checkmark, %%order_class%%.checkout_field .variation-column select',
                    'important' => 'plugin_only',
                ),
            ),
        );

        $this->advanced_fields["form_field"]["bump"] = array(
            'label'          => esc_html__( 'Bump', 'et_builder' ),
            'css'            => array(
                'main' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                'background_color'             => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                'hover_background_color'       => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label:hover i',
                'focus_background_color'       => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                'focus_background_color_hover' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label:hover i',
                'form_text_color'              => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i:before',
                'form_text_color_hover'        => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label:hover i:before',
                'focus_text_color'             => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i:before',
                'focus_text_color_hover'       => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label:hover i:before',
            ),
            'margin_padding' => array(
                'css' => array(
                    'padding'   => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                    'margin' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                ),
            ),
            'box_shadow'     => false,
            'border_styles' => array(
                'bump'       => array(
                    'name'         => 'bump',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                            'border_styles' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]+label i',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( 'Bump', 'et_builder' ),
                ),
                'bump_focus' => array(
                    'name'         => 'bump_focus',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                            'border_styles' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( 'Bump Focus', 'et_builder' ),
                ),
            ),
            'font_field'      => array(
                'css'              => array(
                    'main'      => array(
                        '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i:before',
                    ),
                ),
                'font_size'        => array(
                    'default' => '17px',
                ),
                'hide_font' => true,
                'hide_text_align'  => true,
                'hide_text_shadow'  => true,
                'hide_letter_spacing'  => true,
            ),
            'sizing' => array(
                'css' => array(
                    'main' => '%%order_class%%.checkout_field .checkout_order_bump input[type=checkbox]:checked+label i:before',
                )
            ),
        );

        $this->advanced_fields["form_field"]["product_selector"] = array(
            'label'          => esc_html__( 'Multiple products selector', 'et_builder' ),
            'css'            => array(
                'main' => '%%order_class%%.checkout_field .radio-container .checkmark',
                'background_color'             => '%%order_class%%.checkout_field .radio-container .checkmark',
                'background_color_hover'       => '%%order_class%%.checkout_field .radio-container .checkmark:hover',
                'focus_background_color'       => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark',
                'focus_background_color_hover' => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark:hover',
                'form_text_color'              => '%%order_class%%.checkout_field .radio-container .checkmark,',
                'form_text_color_hover'        => '%%order_class%%.checkout_field .radio-container .checkmark:hover',
                'focus_text_color'             => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark',
                'focus_text_color_hover'       => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark:hover',
            ),
            'margin_padding' => array(
                'css' => array(
                    'padding'   => '%%order_class%%.checkout_field .radio-container .checkmark',
                    'margin' => '%%order_class%%.checkout_field .radio-container .checkmark',
                ),
            ),
            'box_shadow'     => false,
            'border_styles' => array(
                'multi_switcher'       => array(
                    'name'         => 'multi_switcher',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .radio-container .checkmark',
                            'border_styles' => '%%order_class%%.checkout_field .radio-container .checkmark',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( 'Multiple products selector', 'et_builder' ),
                ),
                'multi_switcher_focus' => array(
                    'name'         => 'multi_switcher_focus',
                    'css'          => array(
                        'main' => array(
                            'border_radii'  => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark',
                            'border_styles' => '%%order_class%%.checkout_field .radio-container input:checked~.checkmark',
                        ),
                        'important' => 'all',
                    ),
                    'label_prefix' => esc_html__( ' Multiple products selector focus', 'et_builder' ),
                ),
            ),
            'font_field'     => false
        );
    }

    function get_fields() {

        $north_product = new North_Checkout_Product();
        $north_coupon = new North_Checkout_Coupon();

        $products = $north_product->get_products(-1, true) !== "error" ? $north_product->get_products(-1, true) : null;
        $coupons = $north_coupon->get_coupons(-1, true) !== "error" ? $north_coupon->get_coupons(-1, true) : null;

        $labels = array(
            'link_url'      => esc_html__( 'Link URL', 'et_builder' ),
            'link_text'     => esc_html__( 'Link Text', 'et_builder' ),
            'link_cancel'   => esc_html__( 'Discard Changes', 'et_builder' ),
            'link_save'     => esc_html__( 'Save Changes', 'et_builder' ),
            'link_settings' => esc_html__( 'Option Link', 'et_builder' ),
        );

        $fields = array(
            'field_id' => array(
                'label'            => esc_html__( 'Block ID', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the unique ID of this block. You should use only English characters without special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'default_on_front' => '',
                'option_category'  => 'basic_option',
            ),
            'field_title' => array(
                'label'       => esc_html__( 'Title', 'et_builder' ),
                'type'        => 'text',
                'description' => esc_html__( 'Here you can define the content that will be placed within the current tab.', 'et_builder' ),
                'toggle_slug' => 'main_content',
                'default_on_front' => esc_html__( 'New Block', 'et_builder' ),
                'option_category'  => 'basic_option',
                'mobile_options'   => true,
                'hover'            => 'tabs',
            ),
            'field_type' => array(
                'label'       => esc_html__( 'Type', 'et_builder' ),
                'type'        => 'select',
                'default'     => 'first_name',
                'option_category' => 'basic_option',
                'options'         => array(
                    'first_name'        => esc_html__( 'First name', 'et_builder' ),
                    'last_name'         => esc_html__( 'Last name', 'et_builder' ),
                    'email'             => esc_html__( 'Email', 'et_builder' ),
                    'phone'             => esc_html__( 'Phone Number', 'et_builder' ),
                    'address'           => esc_html__( 'Shipping Address', 'et_builder' ),
                    'product'           => esc_html__( 'Select a Product', 'et_builder' ),
                    'coupon'            => esc_html__( 'Coupon', 'et_builder' ),
                    'dynamic_product'   => esc_html__( 'Name your price', 'et_builder' ),
                    'card'              => esc_html__( 'Card info', 'et_builder' ),
                    'payment_buttons'   => esc_html__( 'Google & Apple Pay', 'et_builder' ),
                    'paypal_buttons'    => esc_html__( 'PayPal buttons', 'et_builder' ),
                    'bump'              => esc_html__( 'Order Bump', 'et_builder' ),
                    'total'             => esc_html__( 'Order Total', 'et_builder' ),
                    'input'             => esc_html__( 'Input Field', 'et_builder' ),
                    'text'              => esc_html__( 'Text Area', 'et_builder' ),
                    'checkbox'          => esc_html__( 'Checkboxes', 'et_builder' ),
                    'radio'             => esc_html__( 'Radio Buttons', 'et_builder' ),
                    'select'            => esc_html__( 'Select Dropdown', 'et_builder' ),
                ),
                'description' => esc_html__( 'Choose the type of field', 'et_builder' ),
                'affects'     => array(
                    'city',
                    'address_line_2',
                    'state',
                    'zip',
                    'country',
                    'checkbox_options',
                    'radio_options',
                    'select_options',
                    'min_length',
                    'max_length',
                    'allowed_symbols',
                    'product_item',
                    'order_bump',
                    'bump_title',
                    'required_mark',
                    'order_before',
                    'order_after',
                    'price_text_before',
                    'price_text_after',
                    'dynamic_input_text_before',
                    'dynamic_input_text_after',
                    'apply_text',
                    'subtotal_label',
                    'discount_label'
                ),
                'toggle_slug' => 'main_content',
            ),
            'product_item'      => array(
                'label'            => esc_html__( 'Product', 'et_builder' ),
                'type'             => 'select',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Here you can select the Product.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'searchable'       => true,
                'options'          => $products,
                'depends_show_if' => 'product',
            ),
            'order_before'      => array(
                'label'            => esc_html__( 'Price text before', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text before displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'total',
            ),
            'order_after'      => array(
                'label'            => esc_html__( 'Price text after', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text after displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'total',
            ),
            'subtotal_label'      => array(
                'label'            => esc_html__( 'Subtotal label', 'et_builder' ),
                'type'             => 'text',
                'default'          => 'Subtotal',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text for subtotal label.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'total',
            ),
            'discount_label'      => array(
                'label'            => esc_html__( 'Discount label', 'et_builder' ),
                'type'             => 'text',
                'default'          => 'Discount',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text for discount label.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'total',
            ),
            'order_bump'      => array(
                'label'            => esc_html__( 'Product', 'et_builder' ),
                'type'             => 'select',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Here you can select the Order Bump Product.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'searchable'       => true,
                'options'          => $products,
                'show_if'         => array(
                    'field_type' => 'bump',
                ),
            ),
            'bump_title' => array(
                'label'            => esc_html__( 'Bump text', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'You can write here any text. If you want to insert the original name of the product, please insert the sign "%name%" in the line', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'default_on_front' => 'Use %name% for product name',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'bump',
                ),
            ),
            'checkbox_checked' => array(
                'label'           => esc_html__( 'Checked By Default', 'et_builder' ),
                'description'     => esc_html__( 'If enabled, the check mark will be automatically selected for the visitor. They can still deselected it.', 'et_builder' ),
                'type'            => 'hidden',
                'option_category' => 'layout',
                'default'         => 'off',
                'depends_show_if' => 'checkbox',
                'toggle_slug'     => 'main_content',
            ),
            'checkbox_options' => array(
                'label'           => esc_html__( 'Options', 'et_builder' ),
                'type'            => 'sortable_list',
                'checkbox'        => true,
                'option_category' => 'basic_option',
                'depends_show_if' => 'checkbox',
                'toggle_slug'     => 'main_content',
                'right_actions'   => 'move|link|copy|delete',
                'labels'          => $labels,
            ),
            'radio_options' => array(
                'label'           => esc_html__( 'Options', 'et_builder' ),
                'type'            => 'sortable_list',
                'radio'           => true,
                'option_category' => 'basic_option',
                'depends_show_if' => 'radio',
                'toggle_slug'     => 'main_content',
                'right_actions'   => 'move|link|copy|delete',
                'labels'          => $labels,
            ),
            'select_options' => array(
                'label'           => esc_html__( 'Options', 'et_builder' ),
                'type'            => 'sortable_list',
                'option_category' => 'basic_option',
                'depends_show_if' => 'select',
                'toggle_slug'     => 'main_content',
            ),
            'apply_text'      => array(
                'label'            => esc_html__( 'Text for Apply button', 'et_builder' ),
                'type'             => 'text',
                'default'          => 'Apply',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text before displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'coupon',
            ),
            'price_text_before'      => array(
                'label'            => esc_html__( 'Price text before', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text before displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'product',
            ),
            'price_text_after'      => array(
                'label'            => esc_html__( 'Price text after', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text after displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'product',
            ),
            'dynamic_input_text'      => array(
                'label'            => esc_html__( 'Main description', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text before displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'dynamic_product',
            ),
            'dynamic_input_text_before'      => array(
                'label'            => esc_html__( 'Input text before', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text before displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'dynamic_product',
            ),
            'dynamic_input_text_after'      => array(
                'label'            => esc_html__( 'Input text after', 'et_builder' ),
                'type'             => 'text',
                'option_category'  => 'basic_option',
                'description'      => esc_html__( 'Set text after displaying of price.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'depends_show_if'  => 'dynamic_product',
            ),
            'address_line_2' => array(
                'label'           => esc_html__( 'Address line 2 field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'on',
                'depends_show_if' => 'address',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define additional apartment field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'          => array(
                    'address_line_2_title',
                ),
            ),
            'address_line_2_title' => array(
                'label'            => esc_html__( 'Address line 2 title', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'default_on_front' => 'Address line 2',
                'option_category'  => 'basic_option',
                'depends_show_if' => 'on',
            ),
            'city' => array(
                'label'           => esc_html__( 'City field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'on',
                'depends_show_if' => 'address',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define additional city field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'          => array(
                    'city_title',
                ),
            ),
            'city_title' => array(
                'label'            => esc_html__( 'City title', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'depends_show_if' => 'on',
                'default_on_front' => 'City',
            ),
            'country' => array(
                'label'           => esc_html__( 'Country field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'on',
                'depends_show_if' => 'address',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define additional country field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'          => array(
                    'country_title',
                ),
            ),
            'country_title' => array(
                'label'            => esc_html__( 'Country title', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'depends_show_if' => 'on',
                'default_on_front' => 'Country',
            ),
            'state' => array(
                'label'           => esc_html__( 'State field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'on',
                'depends_show_if' => 'address',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define additional state field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'          => array(
                    'state_title',
                ),
            ),
            'state_title' => array(
                'label'            => esc_html__( 'State title', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'depends_show_if' => 'on',
                'default_on_front' => 'State',
            ),
            'zip' => array(
                'label'           => esc_html__( 'Zip field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'on',
                'depends_show_if' => 'address',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define additional zip field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'          => array(
                    'zip_title',
                ),
            ),
            'zip_title' => array(
                'label'            => esc_html__( 'Zip title', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'depends_show_if' => 'on',
                'default_on_front' => 'Zip',
            ),
            'min_length'   => array(
                'label'          => esc_html__( 'Minimum Length', 'et_builder' ),
                'description'    => esc_html__( 'Leave at 0 to remove restriction', 'et_builder' ),
                'type'           => 'range',
                'default'        => '0',
                'unitless'       => true,
                'range_settings' => array(
                    'min'  => '0',
                    'max'  => '255',
                    'step' => '1',
                ),
                'option_category' => 'basic_option',
                'show_if'         => array(
                    'field_type' => array('input', 'phone'),
                ),
                'toggle_slug'     => 'main_content',
            ),
            'max_length'   => array(
                'label'          => esc_html__( 'Maximum Length', 'et_builder' ),
                'description'    => esc_html__( 'Leave at 0 to remove restriction', 'et_builder' ),
                'type'           => 'range',
                'default'        => '0',
                'unitless'       => true,
                'range_settings' => array(
                    'min'  => '0',
                    'max'  => '255',
                    'step' => '1',
                ),
                'option_category' => 'basic_option',
                'show_if'         => array(
                    'field_type' => array('input', 'phone'),
                ),
                'toggle_slug'     => 'main_content',
            ),
            'allowed_symbols' => array(
                'label'       => esc_html__( 'Allowed Symbols', 'et_builder' ),
                'type'        => 'select',
                'default'     => 'all',
                'options'     => array(
                    'all'          => esc_html__( 'All', 'et_builder' ),
                    'letters'      => esc_html__( 'Letters Only (A-Z)', 'et_builder' ),
                    'numbers'      => esc_html__( 'Numbers Only (0-9)', 'et_builder' ),
                    'alphanumeric' => esc_html__( 'Alphanumeric Only (A-Z, 0-9)', 'et_builder' ),
                ),
                'option_category' => 'basic_option',
                'show_if'         => array(
                    'field_type' => array('input', 'phone'),
                ),
                'toggle_slug'     => 'main_content',
            ),
            'show_qty' => array(
                'label'           => esc_html__( 'Show quantity', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'show_if'         => array(
                    'field_type' => array('product'),
                ),
                'description'     => esc_html__( 'Show quantity field for current product', 'et_builder' ),
                'toggle_slug'     => 'main_content',
            ),
            'show_inventory' => array(
                'label'           => esc_html__( 'Show Current Inventory', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'show_if'         => array(
                    'field_type' => array('product'),
                ),
                'description'     => esc_html__( 'Show Current Inventory field for current product', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'affects'         => array(
                    'field_inventory_label',
                ),
            ),
            'field_inventory_label' => array(
                'label'           => esc_html__( 'Inventory label', 'et_builder' ),
                'type'            => 'text',
                'default'         => 'Inventory:',
                'option_category' => 'basic_option',
                'depends_show_if' => 'on',
                'description'     => esc_html__( 'Label for inventory. The text will be added underneath the price.', 'et_builder' ),
                'toggle_slug'     => 'main_content',
            ),
            'show_label' => array(
                'label'           => esc_html__( 'Show label', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'off',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'affects'         => array(
                    'field_label',
                ),
                'show_if'         => array(
                    'field_type' => array('first_name', 'last_name', 'phone', 'input', 'email', 'text', 'address', 'select', 'product', 'total', 'dynamic_product', 'coupon'),
                ),
                'description'     => esc_html__( 'Show label for current field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
            ),
            'field_label' => array(
                'label'           => esc_html__( 'Field label', 'et_builder' ),
                'type'            => 'text',
                'default'         => 'Field label',
                'option_category' => 'basic_option',
                'depends_show_if' => 'on',
                'description'     => esc_html__( 'Label for current field', 'et_builder' ),
                'toggle_slug'     => 'main_content',
            ),
            'required_mark' => array(
                'label'           => esc_html__( 'Required Field', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'configuration',
                'default'         => 'off',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'description'     => esc_html__( 'Define whether the field should be required or optional', 'et_builder' ),
                'toggle_slug'     => 'main_content',
                'show_if'         => array(
                    'field_type' => array('first_name', 'last_name', 'phone', 'input', 'email', 'text', 'address', 'select', 'radio', 'checkbox', 'dynamic_price'),
                ),
            ),
            'address_line_2_label' => array(
                'label'            => esc_html__( 'Address line 2 label', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'address',
                    'show_label' => 'on'
                ),
            ),
            'city_label' => array(
                'label'            => esc_html__( 'City label', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'address',
                    'show_label' => 'on'
                ),
            ),
            'country_label' => array(
                'label'            => esc_html__( 'Country label', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'address',
                    'show_label' => 'on'
                ),
            ),
            'state_label' => array(
                'label'            => esc_html__( 'State label', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'address',
                    'show_label' => 'on'
                ),
            ),
            'zip_label' => array(
                'label'            => esc_html__( 'Zip label', 'et_builder' ),
                'type'             => 'text',
                'description'      => esc_html__( 'Define the title of this field. You should not use special characters and spaces.', 'et_builder' ),
                'toggle_slug'      => 'main_content',
                'option_category'  => 'basic_option',
                'show_if'         => array(
                    'field_type' => 'address',
                    'show_label' => 'on'
                ),
            ),
            'half_width_field' => array(
                'label'           => esc_html__( 'Make Half-width', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'layout',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'tab_slug'        => 'advanced',
                'toggle_slug'     => 'layout',
                'description'     => esc_html__( 'If enabled, the field will take 100% of the width of the content area, otherwise it will take 50%', 'et_builder' ),
                'default_on_front' => 'off',
            ),
            'conditional_logic' => array(
                'label'           => esc_html__( 'Enable', 'et_builder' ),
                'type'            => 'yes_no_button',
                'option_category' => 'layout',
                'default'         => 'off',
                'options'         => array(
                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                    'off' => esc_html__( 'No', 'et_builder' ),
                ),
                'affects'         => array(
                    'conditional_logic_rules',
                    'conditional_logic_relation',
                ),
                'description' => et_get_safe_localization( __( "Enabling conditional logic makes this field only visible when any or all of the rules below are fulfilled<br><strong>Note:</strong> Only fields with an unique and non-empty field ID can be used", 'et_builder' ) ),
                'toggle_slug' => 'conditional_logic',
            ),
            'conditional_logic_relation' => array(
                'label'             => esc_html__( 'Relation', 'et_builder' ),
                'type'              => 'yes_no_button',
                'option_category'   => 'layout',
                'options'           => array(
                    'on'  => esc_html__( 'All', 'et_builder' ),
                    'off' => esc_html__( 'Any', 'et_builder' ),
                ),
                'default'           => 'off',
                'button_options'    => array(
                    'button_type' => 'equal',
                ),
                'depends_show_if' => 'on',
                'description' => esc_html__( 'Choose whether any or all of the rules should be fulfilled', 'et_builder' ),
                'toggle_slug' => 'conditional_logic',
            ),
            'conditional_logic_rules' => array(
                'label'           => esc_html__( 'Rules', 'et_builder' ),
                'type'            => 'conditional_logic',
                'option_category' => 'layout',
                'depends_show_if' => 'on',
                'toggle_slug'     => 'conditional_logic',
            ),
        );

        return $fields;
    }

    public function get_transition_fields_css_props() {
        $fields = parent::get_transition_fields_css_props();

        $fields['form_field_background_color'] = array(
            'background' => implode( ', ', array(
                '%%order_class%%.checkout_field .input',
                '%%order_class%%.checkout_field .input + label:hover i'
            ) )
        );

        return $fields;
    }

    function render( $attrs, $content = null, $render_slug ) {
        global $field_counter;

        et_core_nonce_verified_previously();

        $multi_view                 = et_pb_multi_view_options( $this );
        $field_title                = $this->props['field_title'];
        $field_type                 = $this->props['field_type'];
        $field_id                   = $this->props['field_id'];
        $product_id                 = $this->props['product_item'];
        $order_before               = $this->props['order_before'];
        $order_after                = $this->props['order_after'];
        $price_text_before          = $this->props['price_text_before'];
        $price_text_after           = $this->props['price_text_after'];
        $order_bump_id              = $this->props['order_bump'];
        $addr_line_2                = $this->props['address_line_2'];
        $city                       = $this->props['city'];
        $country                    = $this->props['country'];
        $state                      = $this->props['state'];
        $zip                        = $this->props['zip'];
        $apply_text                 = $this->props['apply_text'];
        $bump_title                 = $this->props['bump_title'];
        $addr_line_2_title          = $this->props['address_line_2_title'];
        $city_title                 = $this->props['city_title'];
        $country_title              = $this->props['country_title'];
        $state_title                = $this->props['state_title'];
        $zip_title                  = $this->props['zip_title'];
        $addr_line_2_label          = $this->props['address_line_2_label'];
        $city_label                 = $this->props['city_label'];
        $country_label              = $this->props['country_label'];
        $state_label                = $this->props['state_label'];
        $zip_label                  = $this->props['zip_label'];
        $required_mark              = $this->props['required_mark'];
        $show_label                 = $this->props['show_label'];
        $field_label                = $this->props['field_label'];
        $half_width_field           = $this->props['half_width_field'];
        $form_field_text_color      = $this->props['form_field_text_color'];
        $checkbox_checked           = $this->props['checkbox_checked'];
        $checkbox_options           = $this->props['checkbox_options'];
        $radio_options              = $this->props['radio_options'];
        $select_options             = $this->props['select_options'];
        $min_length                 = $this->props['min_length'];
        $max_length                 = $this->props['max_length'];
        $conditional_logic          = $this->props['conditional_logic'];
        $conditional_logic_relation = $this->props['conditional_logic_relation'];
        $conditional_logic_rules    = $this->props['conditional_logic_rules'];
        $allowed_symbols            = $this->props['allowed_symbols'];
        $dynamic_input              = $this->props['dynamic_input_text'];
        $dynamic_input_before       = $this->props['dynamic_input_text_before'];
        $dynamic_input_after        = $this->props['dynamic_input_text_after'];
        $allowed_symbols            = $this->props['allowed_symbols'];
        $show_qty                   = $this->props['show_qty'];
        $show_inventory             = $this->props['show_inventory'];
        $field_inventory_label      = $this->props['field_inventory_label'];
        $subtotal_label             = $this->props['subtotal_label'];
        $discount_label             = $this->props['discount_label'];
        $render_count               = $this->render_count();
        $field_counter              = ! isset( $field_counter ) ? 0 : $field_counter;
        $current_module_num         = null === $field_counter ? 0 : intval( $field_counter ) + 1;

        $field_text_color_hover        = $this->get_hover_value( 'form_field_text_color' );
        $field_text_color_values       = et_pb_responsive_options()->get_property_values( $this->props, 'form_field_text_color' );
        $field_focus_text_color_hover  = $this->get_hover_value( 'form_field_focus_text_color' );
        $field_focus_text_color_values = et_pb_responsive_options()->get_property_values( $this->props, 'form_field_focus_text_color' );

        // set a field ID.
        if ( '' === $field_id ) {
            $field_id = sprintf( 'field_%d_%d', $field_counter, $render_count );
        }

        if ( 'signup_custom_field' === $render_slug ) {
            $this->add_classname( 'newsletter_field' );
        } else {
            $field_id = strtolower( $field_id );
        }

        $video_background          = $this->video_background();
        $parallax_image_background = $this->get_parallax_image_background();

        $input_field = '';

        // Form Field Text Color - Radio Checked.
        $field_text_color_important = et_builder_has_limitation( 'force_use_global_important' ) ? ' !important' : '';
        et_pb_responsive_options()->generate_responsive_css( $field_text_color_values, '%%order_class%%.checkout_field .input[type="radio"]:checked + label i:before', 'background-color', $render_slug, $field_text_color_important, 'color' );

        if ( et_builder_is_hover_enabled( 'form_field_text_color', $this->props ) ) {
            ET_Builder_Element::set_style( $render_slug, array(
                'selector'    => '%%order_class%%.checkout_field .input[type="radio"]:checked:hover + label i:before',
                'declaration' => sprintf(
                    'background-color: %1$s%2$s;',
                    esc_html( $field_text_color_hover ),
                    $field_text_color_important
                ),
            ) );
        }

        // Form Field Text Color on Focus - Radio Checked.
        et_pb_responsive_options()->generate_responsive_css( $field_focus_text_color_values, '%%order_class%%.checkout_field .input[type="radio"]:checked:active + label i:before', 'background-color', $render_slug, $field_text_color_important, 'color' );

        if ( et_builder_is_hover_enabled( 'form_field_focus_text_color', $this->props ) ) {
            ET_Builder_Element::set_style( $render_slug, array(
                'selector'    => '%%order_class%%.checkout_field .input[type="radio"]:checked:active:hover + label i:before',
                'declaration' => sprintf(
                    'background-color: %1$s%2$s;',
                    esc_html( $field_focus_text_color_hover ),
                    $field_text_color_important
                ),
            ) );
        }

        $pattern         = '';
        $title           = '';
        $min_length      = intval( $min_length );
        $max_length      = intval( $max_length );
        $max_length_attr = '';
        $symbols_pattern = '.';
        $length_pattern  = '*';

        if ( in_array( $allowed_symbols, array( 'letters', 'numbers', 'alphanumeric' ) ) ) {
            switch ( $allowed_symbols ) {
                case 'letters':
                    $symbols_pattern = '[A-Z|a-z|\s-]';
                    $title           = __( ' Only letters allowed.', 'et_builder' );
                    break;
                case 'numbers':
                    $symbols_pattern = '[0-9\s-]';
                    $title           = __( ' Only numbers allowed.', 'et_builder' );
                    break;
                case 'alphanumeric':
                    $symbols_pattern = '[\w\s-]';
                    $title           = __( ' Only letters and numbers allowed.', 'et_builder' );
                    break;
            }
        }

        if ( 0 !== $min_length && 0 !== $max_length ) {
            $max_length = max( $min_length, $max_length );
            $min_length = min( $min_length, $max_length );

            if ( $max_length > 0 ) {
                $max_length_attr = sprintf(
                    ' maxlength="%1$d"',
                    $max_length
                );
            }

            $title .= sprintf(' Min length: %1$s, Max length: %2$s.', esc_attr( $min_length ), esc_attr( $max_length ));
        }

        if ( 0 !== $min_length || 0 !== $max_length ) {
            $length_pattern = '{';

            if ( 0 !== $min_length ) {
                $length_pattern .= $min_length;
            }

            if ( 0 === $max_length ) {
                $length_pattern .= ',';
            }

            if ( 0 === $min_length ) {
                $length_pattern .= '0';
            }

            if ( 0 !== $max_length ) {
                $length_pattern .= ",{$max_length}";
            }

            $length_pattern .= '}';

        }

        if ( '.' !== $symbols_pattern || '*' !== $length_pattern ) {
            $pattern = sprintf(
                ' pattern="%1$s%2$s"',
                esc_attr( $symbols_pattern ),
                esc_attr( $length_pattern )
            );
        }

        if ( '' !== $title ) {
            $title = sprintf(
                ' title="%1$s"',
                esc_attr( $title )
            );
        }

        $conditional_logic_attr = '';

        if ( 'on' === $conditional_logic && ! empty( $conditional_logic_rules ) ) {
            $option_search           = array( '&#91;', '&#93;' );
            $option_replace          = array( '[', ']' );
            $conditional_logic_rules = str_replace( $option_search, $option_replace, $conditional_logic_rules );
            $condition_rows          = json_decode( $conditional_logic_rules );
            $ruleset                 = array();

            foreach ( $condition_rows as $condition_row ) {
                $condition_value = isset( $condition_row->value ) ? $condition_row->value : '';
                $condition_value = trim( $condition_value );

                $ruleset[] = array(
                    $condition_row->field,
                    $condition_row->condition,
                    $condition_value,
                );
            }

            if ( ! empty( $ruleset ) ) {
                $json     = json_encode( $ruleset );
                $relation = $conditional_logic_relation === 'off' ? 'any' : 'all';

                $conditional_logic_attr = sprintf(
                    ' data-conditional-logic="%1$s" data-conditional-relation="%2$s"',
                    esc_attr( $json ),
                    $relation
                );
            }
        }

        switch( $field_type ) {
            case 'card':

                $input_field = sprintf('<div %1$s>
                                    <div class="card-images">
                                        <img src="'. plugin_dir_url(__FILE__) .'../../../public/images/american_express.svg" alt="american_express">
                                        <img src="'. plugin_dir_url( __FILE__) .'../../../public/images/discover.svg" alt="discover">
                                        <img src="'. plugin_dir_url( __FILE__) .'../../../public/images/master.svg" alt="master">
                                        <img src="'. plugin_dir_url( __FILE__) .'../../../public/images/visa.svg" alt="visa">
                                        and more...
                                    </div>
                                    <div id="card-element"></div>
                                    <input type="hidden" name="stripe_token" id="stripe_token" value="">
                                    <input type="hidden" name="card_last_four" id="card_last_four" value="">
                                    <input type="hidden" name="card_brand" id="card_brand" value="">
                                </div>', $conditional_logic_attr);
                break;
            case 'payment_buttons':

                $input_field = sprintf('<div id="payment-request-button"%1$s></div><div class="payment-buttons"%1$s>
                                    
                                </div>', $conditional_logic_attr);
                break;
            case 'paypal_buttons':
                $paypal = new North_Checkout_Paypal();

                if($paypal->is_connected('test') || $paypal->is_connected('live')) {
                    $input_field = '<div id="paypal-buttons" '.$conditional_logic_attr.'></div>';
                }else {
                    $input_field = '<div>Paypal is not connected!</div>';
                }
                break;
            case 'product':

                $north_product = new North_Checkout_Product($product_id);
                $quantity_message = '';
                $out_stock = '';
                $current_quantity = get_post_meta($product_id, 'product_quantity', true);


                if(strlen($current_quantity) && intval($current_quantity) < 1) {
                    $quantity_message = '<span class="out_stock"> (Out of stock)</span>';
                    $out_stock = 'disabled';
                }

                $title = $product_id != 0 ? get_the_title($product_id) : 'Product not selected';

                $variations = $north_product->get_variations();
                $is_checked = '';
                $additional_html = '';
                $product_data = $product_id;
                $product_price = $north_product->get_price_html();
                $price_data = $north_product->get_raw_price();

                if( $north_product->is_variable() ) {

                    $additional_html = '<div class="checkout_product_body">';

                    foreach ($variations as $variation) {

                        $args = array(
                            'north_product' => $north_product,
                            'variation' => $variation,
                            'current_module' => esc_attr( $current_module_num ),
                        );

                        ob_start();

                        if($variation['variation_type'] === 'label') {
                            $north_product->template('variation-template-label','product', $args);
                        }elseif($variation['variation_type'] === 'color') {
                            $north_product->template('variation-template-color','product', $args);
                        }elseif($variation['variation_type'] === 'text') {
                            $north_product->template('variation-template-text','product', $args);
                        }elseif($variation['variation_type'] === 'image') {
                            $north_product->template('variation-template-image','product', $args);
                        }else {
                            $north_product->template('variation-template-select','product', $args);
                        }

                        $additional_html .= ob_get_clean();
                    }

                    $additional_html .= '</div>';

                }

                $quantity_html = '';
                if( $north_product->get_type() === "One time"  && 'on' === $show_qty) {
                    $quantity_html = '<div class="quantity-wrapper"><label class="quantity-label" for="quantity_' . esc_attr( $current_module_num ) .'">Quantity: </label><div class="qty-input"><span class="qty-minus"></span><input type="number" id="quantity_' . esc_attr( $current_module_num ) .'" name="quantity_' . esc_attr( $current_module_num ) .'" value="1"><span class="qty-plus"></span></div></div>';
                }

                $inventory_html = '';
                if( 'on' === $show_inventory) {
                    $inventory_html = '<div class="inventory">' . $field_inventory_label . ' ' . $current_quantity .'</div>';
                }

                $input_field = sprintf(
                    '<div id="checkout_%4$s_%3$s" class="checkout_product %10$s product_%3$s %17$s" data-field_type="%5$s" data-original_id="%4$s" data-module="%3$s" %7$s%9$s>
                                <div class="checkout_product_head">
                                    <div class="product_title_block">
                                        <label class="radio-container">
                                            <input type="radio" name="checkout_product" class="checkout_product_data" data-product="checkout_%4$s_%3$s" value="%8$s" data-type="%13$s" checked="checked">
                                                <span class="checkmark"></span>
                                        </label>
                                        <h4 id="product_name_origin">%1$s%16$s</h4>
                                    </div>
                                    <div class="product_data">
                                        %11$s
                                        <div class="price-block">
                                            <p id="product_single_price" data-price="%15$s" class="price">%2$s</p>
                                        </div>
                                        %12$s
                                        %18$s
                                    </div>
                                </div>
                                %6$s
                                %14$s
                            </div>',
                    esc_attr( $title ),
                    $product_price,
                    esc_attr( $current_module_num ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    $additional_html,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $product_data,
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : '',
                    !empty($price_text_before) ? '<div class="price_before">'. $price_text_before .'</div>' : '',
                    !empty($price_text_after) ? '<div class="price_after">'. $price_text_after .'</div>' : '',
                    $north_product->get_type(),
                    $quantity_html,
                    $price_data,
                    $quantity_message,
                    $out_stock,
                    $inventory_html
                );
                break;
            case 'dynamic_product':

                $input_field = sprintf(
                    '<div id="checkout_%3$s_%2$s" class="checkout_product checkout_dynamic %8$s product_%3$s" data-field_type="product" data-original_id="%3$s" %6$s%7$s>
                                <div class="checkout_product_head">
                                    <div class="product_title_block">
                                        <label class="radio-container">
                                            <input type="radio" name="checkout_product" class="checkout_product_data" data-product="checkout_%3$s_%2$s" value="dynamic_%2$s" data-type="One time" checked="checked">
                                                <span class="checkmark"></span>
                                        </label>
                                        <h4 id="product_name_origin">%1$s</h4>
                                    </div>
                                    <div class="product_data">
                                        %4$s
                                        <div class="price-block" data-currency="%10$s">
                                            <input type="number" name="dynamic_price_%2$s" id="product_single_price" class="price" min="0" step="0.01" value="0">
                                            <input type="hidden" name="dynamic_name_%2$s" id="dynamic_product_name" value="%9$s">
                                        </div>
                                        %5$s
                                    </div>
                                </div>
                            </div>',
                    esc_attr( $dynamic_input ),
                    esc_attr( $current_module_num ),
                    esc_attr( $field_id ),
                    !empty($dynamic_input_before) ? '<div class="price_before">'. esc_attr($dynamic_input_before) .'</div>' : '',
                    !empty($dynamic_input_after) ? '<div class="price_after">'. esc_attr($dynamic_input_after) .'</div>' : '',
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : '',
                    esc_attr( $field_title ),
                    North_Checkout_Admin::convert_code(North_Checkout_Admin::get_current_currency())
                );
                break;
            case 'bump':

                $input_field = '';

                if( $order_bump_id  === 0) {
                    $input_field = sprintf(
                        '<div class="checkout_order_bump" data-field_type="%2$s" data-original_id="%1$s" %3$s%4$s>
                                <h4>Order bump not selected</h4>
                            </div>',
                        esc_attr( $field_id ),
                        esc_attr( $field_type ),
                        $multi_view->render_attrs( array(
                            'attrs' => array(
                                'placeholder' => '{{field_title}}',
                            ),
                        ) ),
                        $conditional_logic_attr
                    );
                }else {

                    $product_price = null;
                    $north_product = new North_Checkout_Product($order_bump_id);
                    $product_type = $north_product->get_type();
                    if($north_product->reload_bump()) {
                        $product_price = $north_product->get_bump_price($order_bump_id);
                    }else {
                        $product_price = $north_product->get_price($order_bump_id);
                    }

                    if($product_type === 'Subscription' && $north_product->get_bump_start_price()) {
                        if($north_product->reload_bump()) {
                            $product_price = $north_product->get_bump_start_price();
                        }else {
                            $product_price = $north_product->get_start_price();
                        }
                    }

                    if($product_type === 'Payment Plan') {
                        if($north_product->reload_bump()) {
                            $product_price = round($product_price / intval($north_product->get_bump_payment_count()), 2);
                        }else {
                            $product_price = round($product_price / intval($north_product->get_payment_count()), 2);
                        }
                    }

                    $title = strpos($bump_title, '%name%') !== false ? str_replace('%name%', get_the_title($order_bump_id), $bump_title) : $bump_title;

                    update_option('order_bump_id_'. $current_module_num, $order_bump_id);

                    $input_field = sprintf(
                        '<div class="checkout_order_bump" data-field_type="%4$s" data-original_id="%3$s" %6$s >
                                <span class="checkout_field_checkbox">
                                    <input type="checkbox" id="checkout_%3$s" name="checkout_bump" value="%7$s" data-price="%5$s" data-module="%2$s">
                                    <label for="checkout_%3$s"><i></i>%1$s</label>
                                </span>
                            </div>',
                        esc_attr( $title ),
                        esc_attr( $current_module_num ),
                        esc_attr( $field_id ),
                        esc_attr( $field_type ),
                        $product_price,
                        $multi_view->render_attrs( array(
                            'attrs' => array(
                                'placeholder' => '{{field_title}}',
                            ),
                        ) ),
                        $order_bump_id
                    );
                }

                break;
            case 'total':

                $currency_code = North_Checkout_Admin::get_current_currency();
                $converted = North_Checkout_Admin::convert_code(North_Checkout_Admin::get_current_currency());
                $price = '<span class="currency">'.$converted.'</span><span id="total_price" class="value">0.00</span>';
                $subtotal_price = '<span class="subtotal-currency">'.$converted.'</span><span id="subtotal_price" class="subtotal-value">0.00</span>';

                if(strtolower($currency_code) === 'dkk') {

                    $price = '<span id="total_price" class="value">0.00</span><span class="currency"> '.$converted.'</span>';
                    $subtotal_price = '<span id="subtotal_price" class="subtotal-value">0.00</span><span class="subtotal-currency"> '.$converted.'</span>';
                }

                $input_field = sprintf(
                    '<div id="checkout_total" class="checkout_total" data-field_type="%2$s" %5$s>
                                <input type="hidden" id="checkout_price" name="checkout_price" value="">
                                <input type="hidden" id="checkout_discount_input" name="checkout_discount_input" value="">
                                <div class="subtotal">
                                    <div class="subtotal-line"><h4>%7$s</h4><p class="subtotal-price">%9$s</p></div>
                                    <div class="subtotal-line"><h4>%8$s <span class="discount-label-help"></span></h4><p class="discount-price" data-type="" data-value=""></p></div>
                                </div>
                                <div class="total-block"><h4>%1$s</h4><p class="price" data-origin=""><span class="before">%3$s</span>%6$s<span class="after">%4$s</span></p></div>
                            </div>',
                    esc_attr( $field_title ),
                    esc_attr( $field_type ),
                    $order_before,
                    $order_after,
                    $conditional_logic_attr,
                    $price,
                    !empty($subtotal_label) ? $subtotal_label : 'Subtotal',
                    !empty($discount_label) ? $discount_label : 'Discount',
                    $subtotal_price
                );
                break;
            case 'text':
            case 'textarea':
                $input_field = sprintf(
                    '<textarea name="checkout_input_%2$s" id="checkout_%2$s" class="checkout_message input text-input %5$s %8$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s"%6$s%7$s>%1$s</textarea>',
                    ( isset( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ? esc_html( sanitize_text_field( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'address':

                $additional_fields = '';
                $field_title = $field_title === 'New Block' ? 'Address line 1' : $field_title;

                if($addr_line_2 === 'on') {
                    $value = isset( $_POST['checkout_line_2'] ) ? esc_attr( sanitize_text_field( $_POST['checkout_line_2'] ) ) : '' ;
                    $additional_fields .= '<div class="input_apartment"><label class="field_label">'.esc_html($addr_line_2_label).'</label><input type="text" id="checkout_line_2_'. $field_id. '" class="input" value="'. $value .'" name="checkout_line_2" placeholder="'. $addr_line_2_title .'"></div>';
                }

                if($city === 'on') {
                    $value = isset( $_POST['checkout_city'] ) ? esc_attr( sanitize_text_field( $_POST['checkout_city'] ) ) : '' ;
                    $additional_fields .= '<div class="input_city"><label class="field_label">'.esc_html($city_label).'</label><input type="text" id="checkout_city_'. $field_id. '" class="input" value="'. $value .'" name="checkout_city" placeholder="'. $city_title .'"></div>';
                }

                if($state === 'on') {
                    $value = isset( $_POST['checkout_state'] ) ? esc_attr( sanitize_text_field( $_POST['checkout_state'] ) ) : '' ;
                    $additional_fields .= '<div class="input_state"><label class="field_label">'.esc_html($state_label).'</label><input type="text" id="checkout_state_'. $field_id. '" class="input" value="'. $value .'" name="checkout_state" placeholder="'. $state_title .'"></div>';
                }

                if($zip === 'on') {
                    $value = isset( $_POST['checkout_zip'] ) ? esc_attr( sanitize_text_field( $_POST['checkout_zip'] ) ) : '' ;
                    $additional_fields .= '<div class="input_zip"><label class="field_label">'.esc_html($zip_label).'</label><input type="text" id="checkout_zip_'. $field_id. '" class="input" value="'. $value .'" name="checkout_zip" placeholder="'. $zip_title .'"></div>';
                }

                if($country === 'on') {
                    $value = isset( $_POST['checkout_country'] ) ? esc_attr( sanitize_text_field( $_POST['checkout_country'] ) ) : '' ;
                    $additional_fields .= '<div class="input_country"><label class="field_label">'.esc_html($country_label).'</label><input type="text" id="checkout_country_'. $field_id. '" class="input" value="'. $value .'" name="checkout_country" placeholder="'. $country_title .'"></div>';
                }

                $input_field = sprintf(
                    '<input type="text" id="checkout_address_%3$s" class="input text-input input_autocomplete %6$s %13$s" value="%1$s" name="checkout_address" data-field_type="%4$s" data-original_id="%3$s" onFocus="initAutocomplete(this)" placeholder="%5$s"%7$s%8$s%9$s%10$s%12$s>
                            <div class="additional_address" %12$s>    
                                %11$s
                            </div>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $current_module_num ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $pattern,
                    $title,
                    $max_length_attr,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $additional_fields,
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'coupon':
                $input_field = sprintf(
                    '<div class="coupon-wrap"><input type="text" id="checkout_coupon_%2$s" class="input text-input checkout-coupon %7$s" value="%1$s" name="checkout_coupon_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %5$s%6$s><button class="apply-coupon"><span>%8$s</span><div class="loader"></div></button></div>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : '',
                    !empty($apply_text) ? $apply_text : 'Apply'
                );
                break;
            case 'first_name':
                $input_field = sprintf(
                    '<input type="text" id="checkout_first_%2$s" class="input text-input %5$s %10$s" value="%1$s" name="checkout_first_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %6$s%7$s%8$s%9$s>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $title,
                    $max_length_attr,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'last_name':
                $input_field = sprintf(
                    '<input type="text" id="checkout_last_%2$s" class="input text-input %5$s %10$s" value="%1$s" name="checkout_last_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %6$s%7$s%8$s%9$s>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $title,
                    $max_length_attr,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'phone':
                $input_field = sprintf(
                    '<input type="tel" id="checkout_phone_%2$s" class="input text-input %5$s %11$s" value="%1$s" name="checkout_phone_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %6$s%7$s%8$s%9$s%10$s>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $title,
                    $max_length_attr,
                    $pattern,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'input' :
                $input_field = sprintf(
                    '<input type="text" id="checkout_text_%2$s" class="input text-input %5$s %11$s" value="%1$s" name="checkout_text_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %6$s%7$s%8$s%9$s%10$s>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $title,
                    $max_length_attr,
                    $pattern,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'email' :
                $pattern = '';

                $input_field = sprintf(
                    '<input type="email" id="checkout_email_%2$s" class="input text-input %5$s %11$s" value="%1$s" name="checkout_email_%2$s" data-field_type="%3$s" data-original_id="%2$s" placeholder="%4$s" %6$s%7$s%8$s%9$s%10$s>',
                    ( isset( $_POST['checkout_' . $field_id] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id] ) ) : '' ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $pattern,
                    $title,
                    $max_length_attr,
                    $multi_view->render_attrs( array(
                        'attrs' => array(
                            'placeholder' => '{{field_title}}',
                        ),
                    ) ),
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
            case 'checkbox' :
                $input_field = '';

                if ( ! $checkbox_options ) {
                    $is_checked       = ! empty( $checkbox_checked ) && 'on' === $checkbox_checked;
                    $checkbox_options = sprintf(
                        '[{"value":"%1$s","checked":%2$s}]',
                        esc_attr( $field_title ),
                        $is_checked ? 1 : 0
                    );
                    $field_title = '';
                }

                $option_search    = array( '&#91;', '&#93;' );
                $option_replace   = array( '[', ']' );
                $checkbox_options = str_replace( $option_search, $option_replace, $checkbox_options );
                $checkbox_options = json_decode( $checkbox_options );

                foreach ( $checkbox_options as $index => $option ) {
                    $is_checked   = 1 === $option->checked ? true : false;
                    $option_value = wp_strip_all_tags( $option->value );
                    $drag_id      = isset( $option->dragID ) ? $option->dragID : '';
                    $option_id    = isset( $option->id ) ? $option->id : $drag_id;
                    $option_id    = sprintf( ' data-id="%1$s"', esc_attr( $option_id ) );
                    $option_label = wp_strip_all_tags( $option->value );
                    $option_link  = '';

                    if ( ! empty( $option->link_url ) ) {
                        $link_text   = isset( $option->link_text ) ? $option->link_text : '';
                        $option_link = sprintf( ' <a href="%1$s" target="_blank">%2$s</a>', esc_url( $option->link_url ), esc_html( $link_text ) );
                    }

                    // The required field needs a value, use link information if the option value is empty
                    if ( 'off' !== $required_mark && empty( $option_value ) && ! empty( $option_link ) ){
                        $option_value = isset( $option->link_text ) && ! empty( $option->link_text ) ? esc_html( $option->link_text ) : esc_url( $option->link_url );
                    }

                    $input_field .= sprintf(
                        '<span class="checkout_field_checkbox">
							<input type="checkbox" id="checkout_%1$s_%3$s" class="input %10$s" name="checkout_checkbox_%1$s[]" value="%2$s"%4$s%6$s%9$s>
							<label for="checkout_%1$s_%3$s"><i></i>%7$s%8$s</label>
						</span>',
                        esc_attr( $field_id ),
                        esc_attr( $option_value ),
                        esc_attr( $index ),
                        $is_checked ? ' checked="checked"' : '',
                        esc_attr( $render_count ), // #5
                        $option_id,
                        $option_label,
                        $option_link,
                        $conditional_logic_attr,
                        !empty($conditional_logic_attr) ? 'condition_field' : ''
                    );
                }

                $input_field = sprintf(
                    '<span class="checkout_field_options_wrapper">
                                <span class="checkout_field_options_title"%7$s>%5$s</span>
                                <span class="checkout_field_options_list">%6$s</span>
                            </span>',
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    esc_attr( $current_module_num ),
                    esc_html( $field_title ),
                    $input_field,
                    $multi_view->render_attrs( array(
                        'content' => '{{field_title}}',
                    ) )
                );

                break;
            case 'radio' :
                $input_field = '';

                if ( $radio_options ) {
                    $option_search  = array( '&#91;', '&#93;' );
                    $option_replace = array( '[', ']' );
                    $radio_options  = str_replace( $option_search, $option_replace, $radio_options );
                    $radio_options  = json_decode( $radio_options );

                    foreach ( $radio_options as $index => $option ) {
                        $is_checked  = 1 === $option->checked ? true : false;
                        $drag_id     = isset( $option->dragID ) ? $option->dragID : '';
                        $option_id   = isset( $option->id ) ? $option->id : $drag_id;
                        $option_id   = sprintf( ' data-id="%1$s"', esc_attr( $option_id ) );
                        $option_link = '';

                        if ( ! empty( $option->link_url ) ) {
                            $link_text   = isset( $option->link_text ) ? $option->link_text : '';
                            $option_link = sprintf( ' <a href="%1$s" target="_blank">%2$s</a>', esc_url( $option->link_url ), esc_html( $link_text ) );
                        }

                        $input_field .= sprintf(
                            '<span class="checkout_field_radio">
								<input type="radio" id="checkout_%3$s_%7$s" class="input %6$s %14$s" value="%8$s" name="checkout_radio_%3$s" data-field_type="%4$s" data-original_id="%3$s" %9$s%11$s%13$s>
								<label for="checkout_%3$s_%7$s"><i></i>%8$s%12$s</label>
							</span>',
                            ( isset( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ) : '' ),
                            esc_attr( $current_module_num ),
                            esc_attr( $field_id ),
                            esc_attr( $field_type ),
                            esc_attr( $field_title ), // #5
                            'off' === $required_mark ? 'not_required' : 'required',
                            esc_attr( $index ),
                            esc_attr( wp_strip_all_tags( $option->value ) ),
                            checked( $is_checked, true, false ),
                            esc_attr( $render_count ), // #10
                            $option_id,
                            $option_link,
                            $conditional_logic_attr,
                            !empty($conditional_logic_attr) ? 'condition_field' : ''
                        );
                    }
                } else {
                    $input_field .= esc_html__( 'No options added.', 'et_builder' );
                }

                $input_field = sprintf(
                    '<span class="checkout_field_options_wrapper">
						<span class="checkout_field_options_title"%3$s>%1$s</span>
						<span class="checkout_field_options_list">%2$s</span>
					</span>',
                    esc_html( $field_title ),
                    $input_field,
                    $multi_view->render_attrs( array(
                        'content' => '{{field_title}}',
                    ) )
                );

                break;
            case 'select' :
                $options = sprintf(
                    '<option value=""%2$s>%1$s</option>',
                    esc_html( $field_title ),
                    $multi_view->render_attrs( array(
                        'content' => '{{field_title}}',
                    ) )
                );

                if ( $select_options ) {
                    $option_search  = array( '&#91;', '&#93;' );
                    $option_replace = array( '[', ']' );
                    $select_options = str_replace( $option_search, $option_replace, $select_options );
                    $select_options = json_decode( $select_options );

                    foreach ( $select_options as $option ) {
                        $option_id = isset( $option->id ) ? sprintf( ' data-id="%1$s"', esc_attr( $option->id ) ) : '';

                        $options .= sprintf(
                            '<option value="%1$s"%3$s>%2$s</option>',
                            esc_attr( wp_strip_all_tags( $option->value ) ),
                            wp_strip_all_tags( $option->value ),
                            $option_id
                        );
                    }
                }

                $input_field = sprintf(
                    '<select id="checkout_%3$s" class="checkout_select input %6$s%9$s" name="checkout_select_%3$s" data-field_type="%4$s" data-original_id="%3$s" %8$s>
						%7$s
					</select>',
                    ( isset( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ? esc_attr( sanitize_text_field( $_POST['checkout_' . $field_id . '_' . $current_module_num] ) ) : '' ),
                    esc_attr( $current_module_num ),
                    esc_attr( $field_id ),
                    esc_attr( $field_type ),
                    esc_attr( $field_title ),
                    'off' === $required_mark ? 'not_required' : 'required',
                    $options,
                    $conditional_logic_attr,
                    !empty($conditional_logic_attr) ? 'condition_field' : ''
                );
                break;
        }

        // Module classnames
        $this->add_classname( array(
            $this->get_text_orientation_classname(),
        ) );

        if ( 'on' === $half_width_field) {
            $this->add_classname( 'checkout_field_half' );
        }

        if ( 'on' === $half_width_field  && $field_type == 'address'  && $field_counter % 2 == 0) {
            $this->add_classname( 'right' );
        }

        if ( $field_type == 'dynamic_product' ) {
            $this->add_classname( 'checkout_field_product' );
        }

        $label = '';
        if ( 'on' === $show_label) {
            $label_text = !empty($field_label) ? esc_html( $field_label ) : 'Field label';
            $input_field = '<label class="field_label">'. esc_html( $field_label ) .'</label>'. $input_field;
        }

        $this->add_classname( 'checkout_field_' .  $field_type);

        if ( 'on' === self::$_->array_get( $this->props, 'hidden' ) ) {
            $this->add_classname( 'checkout_field--hidden' );
        }

        // Remove automatically added classname
        $this->remove_classname( 'et_pb_module' );

//        if ( !empty($conditional_logic_attr) ) {
//            $this->add_classname( 'conditional');
//        }

//        $output = sprintf('%1$s%2$s', $label, $input_field);

        $field_counter++;

        return $input_field;
    }
}

new North_checkout_Item;