<?php

namespace NorthStripe\Service;

class AccountLinkService extends \NorthStripe\Service\AbstractService
{
    /**
     * Creates an AccountLink object that returns a single-use NorthStripe URL that the user
     * can redirect their user to in order to take them through the Connect Onboarding
     * flow.
     *
     * @param null|array $params
     * @param null|array|\NorthStripe\Util\RequestOptions $opts
     *
     * @throws \NorthStripe\Exception\ApiErrorException if the request fails
     *
     * @return \NorthStripe\AccountLink
     */
    public function create($params = null, $opts = null)
    {
        return $this->request('post', '/v1/account_links', $params, $opts);
    }
}
