<?php

namespace NorthStripe\Service;

class BalanceService extends \NorthStripe\Service\AbstractService
{
    /**
     * Retrieves the current account balance, based on the authentication that was used
     * to make the request.  For a sample request, see <a
     * href="/docs/connect/account-balances#accounting-for-negative-balances">Accounting
     * for negative balances</a>.
     *
     * @param null|array $params
     * @param null|array|\NorthStripe\Util\RequestOptions $opts
     *
     * @throws \NorthStripe\Exception\ApiErrorException if the request fails
     *
     * @return \NorthStripe\Balance
     */
    public function retrieve($params = null, $opts = null)
    {
        return $this->request('get', '/v1/balance', $params, $opts);
    }
}
