<?php

namespace NorthStripe;

/**
 * Client used to send requests to Stripe's API.
 *
 * @property \NorthStripe\Service\AccountLinkService $accountLinks
 * @property \NorthStripe\Service\AccountService $accounts
 * @property \NorthStripe\Service\ApplePayDomainService $applePayDomains
 * @property \NorthStripe\Service\ApplicationFeeService $applicationFees
 * @property \NorthStripe\Service\BalanceService $balance
 * @property \NorthStripe\Service\BalanceTransactionService $balanceTransactions
 * @property \NorthStripe\Service\BillingPortal\BillingPortalServiceFactory $billingPortal
 * @property \NorthStripe\Service\ChargeService $charges
 * @property \NorthStripe\Service\Checkout\CheckoutServiceFactory $checkout
 * @property \NorthStripe\Service\CountrySpecService $countrySpecs
 * @property \NorthStripe\Service\CouponService $coupons
 * @property \NorthStripe\Service\CreditNoteService $creditNotes
 * @property \NorthStripe\Service\CustomerService $customers
 * @property \NorthStripe\Service\DisputeService $disputes
 * @property \NorthStripe\Service\EphemeralKeyService $ephemeralKeys
 * @property \NorthStripe\Service\EventService $events
 * @property \NorthStripe\Service\ExchangeRateService $exchangeRates
 * @property \NorthStripe\Service\FileLinkService $fileLinks
 * @property \NorthStripe\Service\FileService $files
 * @property \NorthStripe\Service\InvoiceItemService $invoiceItems
 * @property \NorthStripe\Service\InvoiceService $invoices
 * @property \NorthStripe\Service\Issuing\IssuingServiceFactory $issuing
 * @property \NorthStripe\Service\MandateService $mandates
 * @property \NorthStripe\Service\OrderReturnService $orderReturns
 * @property \NorthStripe\Service\OrderService $orders
 * @property \NorthStripe\Service\PaymentIntentService $paymentIntents
 * @property \NorthStripe\Service\PaymentMethodService $paymentMethods
 * @property \NorthStripe\Service\PayoutService $payouts
 * @property \NorthStripe\Service\PlanService $plans
 * @property \NorthStripe\Service\PriceService $prices
 * @property \NorthStripe\Service\ProductService $products
 * @property \NorthStripe\Service\Radar\RadarServiceFactory $radar
 * @property \NorthStripe\Service\RefundService $refunds
 * @property \NorthStripe\Service\Reporting\ReportingServiceFactory $reporting
 * @property \NorthStripe\Service\ReviewService $reviews
 * @property \NorthStripe\Service\SetupIntentService $setupIntents
 * @property \NorthStripe\Service\Sigma\SigmaServiceFactory $sigma
 * @property \NorthStripe\Service\SkuService $skus
 * @property \NorthStripe\Service\SourceService $sources
 * @property \NorthStripe\Service\SubscriptionItemService $subscriptionItems
 * @property \NorthStripe\Service\SubscriptionScheduleService $subscriptionSchedules
 * @property \NorthStripe\Service\SubscriptionService $subscriptions
 * @property \NorthStripe\Service\TaxRateService $taxRates
 * @property \NorthStripe\Service\Terminal\TerminalServiceFactory $terminal
 * @property \NorthStripe\Service\TokenService $tokens
 * @property \NorthStripe\Service\TopupService $topups
 * @property \NorthStripe\Service\TransferService $transfers
 * @property \NorthStripe\Service\WebhookEndpointService $webhookEndpoints
 */
class StripeClient extends BaseStripeClient
{
    /**
     * @var \NorthStripe\Service\CoreServiceFactory
     */
    private $coreServiceFactory;

    public function __get($name)
    {
        if (null === $this->coreServiceFactory) {
            $this->coreServiceFactory = new \NorthStripe\Service\CoreServiceFactory($this);
        }

        return $this->coreServiceFactory->__get($name);
    }
}
