<?php

namespace NorthStripe\Util;

class ObjectTypes
{
    /**
     * @var array Mapping from object types to resource classes
     */
    const mapping = [
        \NorthStripe\Account::OBJECT_NAME => \NorthStripe\Account::class,
        \NorthStripe\AccountLink::OBJECT_NAME => \NorthStripe\AccountLink::class,
        \NorthStripe\AlipayAccount::OBJECT_NAME => \NorthStripe\AlipayAccount::class,
        \NorthStripe\ApplePayDomain::OBJECT_NAME => \NorthStripe\ApplePayDomain::class,
        \NorthStripe\ApplicationFee::OBJECT_NAME => \NorthStripe\ApplicationFee::class,
        \NorthStripe\ApplicationFeeRefund::OBJECT_NAME => \NorthStripe\ApplicationFeeRefund::class,
        \NorthStripe\Balance::OBJECT_NAME => \NorthStripe\Balance::class,
        \NorthStripe\BalanceTransaction::OBJECT_NAME => \NorthStripe\BalanceTransaction::class,
        \NorthStripe\BankAccount::OBJECT_NAME => \NorthStripe\BankAccount::class,
        \NorthStripe\BillingPortal\Session::OBJECT_NAME => \NorthStripe\BillingPortal\Session::class,
        \NorthStripe\BitcoinReceiver::OBJECT_NAME => \NorthStripe\BitcoinReceiver::class,
        \NorthStripe\BitcoinTransaction::OBJECT_NAME => \NorthStripe\BitcoinTransaction::class,
        \NorthStripe\Capability::OBJECT_NAME => \NorthStripe\Capability::class,
        \NorthStripe\Card::OBJECT_NAME => \NorthStripe\Card::class,
        \NorthStripe\Charge::OBJECT_NAME => \NorthStripe\Charge::class,
        \NorthStripe\Checkout\Session::OBJECT_NAME => \NorthStripe\Checkout\Session::class,
        \NorthStripe\Collection::OBJECT_NAME => \NorthStripe\Collection::class,
        \NorthStripe\CountrySpec::OBJECT_NAME => \NorthStripe\CountrySpec::class,
        \NorthStripe\Coupon::OBJECT_NAME => \NorthStripe\Coupon::class,
        \NorthStripe\CreditNote::OBJECT_NAME => \NorthStripe\CreditNote::class,
        \NorthStripe\CreditNoteLineItem::OBJECT_NAME => \NorthStripe\CreditNoteLineItem::class,
        \NorthStripe\Customer::OBJECT_NAME => \NorthStripe\Customer::class,
        \NorthStripe\CustomerBalanceTransaction::OBJECT_NAME => \NorthStripe\CustomerBalanceTransaction::class,
        \NorthStripe\Discount::OBJECT_NAME => \NorthStripe\Discount::class,
        \NorthStripe\Dispute::OBJECT_NAME => \NorthStripe\Dispute::class,
        \NorthStripe\EphemeralKey::OBJECT_NAME => \NorthStripe\EphemeralKey::class,
        \NorthStripe\Event::OBJECT_NAME => \NorthStripe\Event::class,
        \NorthStripe\ExchangeRate::OBJECT_NAME => \NorthStripe\ExchangeRate::class,
        \NorthStripe\File::OBJECT_NAME => \NorthStripe\File::class,
        \NorthStripe\File::OBJECT_NAME_ALT => \NorthStripe\File::class,
        \NorthStripe\FileLink::OBJECT_NAME => \NorthStripe\FileLink::class,
        \NorthStripe\Invoice::OBJECT_NAME => \NorthStripe\Invoice::class,
        \NorthStripe\InvoiceItem::OBJECT_NAME => \NorthStripe\InvoiceItem::class,
        \NorthStripe\InvoiceLineItem::OBJECT_NAME => \NorthStripe\InvoiceLineItem::class,
        \NorthStripe\Issuing\Authorization::OBJECT_NAME => \NorthStripe\Issuing\Authorization::class,
        \NorthStripe\Issuing\Card::OBJECT_NAME => \NorthStripe\Issuing\Card::class,
        \NorthStripe\Issuing\CardDetails::OBJECT_NAME => \NorthStripe\Issuing\CardDetails::class,
        \NorthStripe\Issuing\Cardholder::OBJECT_NAME => \NorthStripe\Issuing\Cardholder::class,
        \NorthStripe\Issuing\Dispute::OBJECT_NAME => \NorthStripe\Issuing\Dispute::class,
        \NorthStripe\Issuing\Transaction::OBJECT_NAME => \NorthStripe\Issuing\Transaction::class,
        \NorthStripe\LineItem::OBJECT_NAME => \NorthStripe\LineItem::class,
        \NorthStripe\LoginLink::OBJECT_NAME => \NorthStripe\LoginLink::class,
        \NorthStripe\Mandate::OBJECT_NAME => \NorthStripe\Mandate::class,
        \NorthStripe\Order::OBJECT_NAME => \NorthStripe\Order::class,
        \NorthStripe\OrderItem::OBJECT_NAME => \NorthStripe\OrderItem::class,
        \NorthStripe\OrderReturn::OBJECT_NAME => \NorthStripe\OrderReturn::class,
        \NorthStripe\PaymentIntent::OBJECT_NAME => \NorthStripe\PaymentIntent::class,
        \NorthStripe\PaymentMethod::OBJECT_NAME => \NorthStripe\PaymentMethod::class,
        \NorthStripe\Payout::OBJECT_NAME => \NorthStripe\Payout::class,
        \NorthStripe\Person::OBJECT_NAME => \NorthStripe\Person::class,
        \NorthStripe\Plan::OBJECT_NAME => \NorthStripe\Plan::class,
        \NorthStripe\Price::OBJECT_NAME => \NorthStripe\Price::class,
        \NorthStripe\Product::OBJECT_NAME => \NorthStripe\Product::class,
        \NorthStripe\Radar\EarlyFraudWarning::OBJECT_NAME => \NorthStripe\Radar\EarlyFraudWarning::class,
        \NorthStripe\Radar\ValueList::OBJECT_NAME => \NorthStripe\Radar\ValueList::class,
        \NorthStripe\Radar\ValueListItem::OBJECT_NAME => \NorthStripe\Radar\ValueListItem::class,
        \NorthStripe\Recipient::OBJECT_NAME => \NorthStripe\Recipient::class,
        \NorthStripe\RecipientTransfer::OBJECT_NAME => \NorthStripe\RecipientTransfer::class,
        \NorthStripe\Refund::OBJECT_NAME => \NorthStripe\Refund::class,
        \NorthStripe\Reporting\ReportRun::OBJECT_NAME => \NorthStripe\Reporting\ReportRun::class,
        \NorthStripe\Reporting\ReportType::OBJECT_NAME => \NorthStripe\Reporting\ReportType::class,
        \NorthStripe\Review::OBJECT_NAME => \NorthStripe\Review::class,
        \NorthStripe\SetupIntent::OBJECT_NAME => \NorthStripe\SetupIntent::class,
        \NorthStripe\Sigma\ScheduledQueryRun::OBJECT_NAME => \NorthStripe\Sigma\ScheduledQueryRun::class,
        \NorthStripe\SKU::OBJECT_NAME => \NorthStripe\SKU::class,
        \NorthStripe\Source::OBJECT_NAME => \NorthStripe\Source::class,
        \NorthStripe\SourceTransaction::OBJECT_NAME => \NorthStripe\SourceTransaction::class,
        \NorthStripe\Subscription::OBJECT_NAME => \NorthStripe\Subscription::class,
        \NorthStripe\SubscriptionItem::OBJECT_NAME => \NorthStripe\SubscriptionItem::class,
        \NorthStripe\SubscriptionSchedule::OBJECT_NAME => \NorthStripe\SubscriptionSchedule::class,
        \NorthStripe\TaxId::OBJECT_NAME => \NorthStripe\TaxId::class,
        \NorthStripe\TaxRate::OBJECT_NAME => \NorthStripe\TaxRate::class,
        \NorthStripe\Terminal\ConnectionToken::OBJECT_NAME => \NorthStripe\Terminal\ConnectionToken::class,
        \NorthStripe\Terminal\Location::OBJECT_NAME => \NorthStripe\Terminal\Location::class,
        \NorthStripe\Terminal\Reader::OBJECT_NAME => \NorthStripe\Terminal\Reader::class,
        \NorthStripe\ThreeDSecure::OBJECT_NAME => \NorthStripe\ThreeDSecure::class,
        \NorthStripe\Token::OBJECT_NAME => \NorthStripe\Token::class,
        \NorthStripe\Topup::OBJECT_NAME => \NorthStripe\Topup::class,
        \NorthStripe\Transfer::OBJECT_NAME => \NorthStripe\Transfer::class,
        \NorthStripe\TransferReversal::OBJECT_NAME => \NorthStripe\TransferReversal::class,
        \NorthStripe\UsageRecord::OBJECT_NAME => \NorthStripe\UsageRecord::class,
        \NorthStripe\UsageRecordSummary::OBJECT_NAME => \NorthStripe\UsageRecordSummary::class,
        \NorthStripe\WebhookEndpoint::OBJECT_NAME => \NorthStripe\WebhookEndpoint::class,
    ];
}
