<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://northplugins.com/
 * @since             1.0
 * @package           North_Checkout
 *
 * @wordpress-plugin
 * Plugin Name:       North Checkout
 * Plugin URI:        https://northplugins.com/
 * Description:       North Check is an easy to use ecommerce plugin that lets you create dynamic high converting sales pages.
 * Version:           2.7.5
 * Author:            North Plugins
 * Author URI:        https://northplugins.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       north-checkout
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Currently plugin version.
 */
$plugin_data = get_file_data( __FILE__, [ 'version' => 'Version' ] );
define( 'NORTH_CHECKOUT_VERSION', $plugin_data['version'] );

/**
 * Plugin secret key.
 */
define('NORTH_SECRET_KEY', '5edbc30323e629.92032856');

/**
 * Plugin license server.
 */
define('NORTH_LICENSE_SERVER_URL', 'https://northplugins.com');

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-north-checkout-activator.php
 */
function activate_north_checkout() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-north-checkout-activator.php';
	North_Checkout_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-north-checkout-deactivator.php
 */
function deactivate_north_checkout() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-north-checkout-deactivator.php';
	North_Checkout_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_north_checkout' );
register_deactivation_hook( __FILE__, 'deactivate_north_checkout' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-north-checkout.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0
 */
function run_north_checkout() {

	$plugin = new North_Checkout();
	$plugin->run();

}
run_north_checkout();
