let paypalButtons = null;

function paypalInit() {

    let product = jQuery('#payment-form .checkout_product_data:checked').data("type");

    if(product !== 'One time') {

        if ( jQuery( "#paypal-buttons" ).length ) {
            paypalButtons = paypal.Buttons({
                onClick: function (data, actions) {

                    let form = jQuery('#payment-form');
                    let valid = true;
                    let error_message = '';

                    jQuery(form).find('.checkout_field .required').each(function () {

                        if (jQuery(this).val() === '') {
                            jQuery(this).addClass("et_checkout_error");
                            valid = false;
                            error_message += '<li>' + jQuery(this).attr("placeholder") + '</li>';
                        }
                    });

                    jQuery(form).find('.checkout_field input[pattern]').each(function () {

                        let pattern = new RegExp(jQuery(this).attr("pattern"));

                        if (!pattern.test(String(jQuery(this).val()))) {
                            jQuery(this).addClass("et_checkout_error");
                            valid = false;
                            error_message += '<li>' + jQuery(this).attr("placeholder") + ' (' + jQuery(this).attr("title") + ' )</li>';
                        }
                    });

                    jQuery(form).find('.checkout_field_email #checkout_email_email').each(function () {
                        if (jQuery(this).val() !== '' && !validateEmail(jQuery(this).val())) {
                            jQuery(this).addClass("et_checkout_error");
                            valid = false;
                            error_message += '<li>Email address not valid</li>';
                        }
                    });

                    if (!valid) {
                        jQuery('#card-errors').html('<p>Please, fill in the following fields:</p><ul>' + error_message + '</ul>');
                        jQuery('html, body').animate({
                            scrollTop: jQuery("#card-errors").offset().top - 150
                        }, 500);

                        return actions.reject();
                    } else {
                        return actions.resolve();
                    }
                },
                createSubscription: function (data, actions) {
                    var data = new FormData();
                    var form = jQuery('#payment-form').serialize();

                    data.append('action', 'paypal_payment_process');
                    data.append('form', form);

                    return fetch(ajax_object.ajaxurl, {
                        method: 'post',
                        body: data,
                        credentials: 'same-origin'
                    }).then((response) => response.json())
                        .then((data) => {
                            return actions.subscription.create({
                                'plan_id': data.id
                            });
                        })
                        .catch((error) => {
                            console.log('Payment Error:');
                            console.dir(error);
                        });

                },
                onApprove: function (data, actions) {
                    var data = new FormData();
                    var form = jQuery('#payment-form');
                    var form_serialize = form.serialize();
                    var redirect = form.data("redirect");

                    data.append('action', 'paypal_order_create');
                    data.append('form', form_serialize);
                    data.append('success', true);

                    return fetch(ajax_object.ajaxurl, {
                        method: 'post',
                        body: data,
                        credentials: 'same-origin'
                    }).then((response) => response.json()).then((data) => {
                        if (redirect === '') {
                            jQuery('.modal-checkout').fadeIn('fast');
                        } else {
                            window.location.href = redirect;
                        }
                    }).catch((error) => {
                        console.log('Payment Error:');
                        console.dir(error);
                    });

                },
                onError: function (err) {
                    var data = new FormData();
                    var form = jQuery('#payment-form');
                    var form_serialize = form.serialize();
                    var redirect = form.data("redirect");

                    data.append('action', 'paypal_order_create');
                    data.append('form', form_serialize);
                    data.append('success', false);

                    return fetch(ajax_object.ajaxurl, {
                        method: 'post',
                        body: data,
                        credentials: 'same-origin'
                    }).then((response) => response.json()).then((data) => {
                        if (redirect === '') {
                            jQuery('.modal-checkout').fadeIn('fast');
                        } else {
                            window.location.href = redirect;
                        }
                    }).catch((error) => {
                        console.log('Payment Error:');
                        console.dir(error);
                    });
                }
            });

            paypalButtons.render('#paypal-buttons');

        }

    }else {

        if ( jQuery( "#paypal-buttons" ).length ) {

            paypalButtons = paypal.Buttons({
                    onClick: function (data, actions) {

                        var data = new FormData();
                        let form = jQuery('#payment-form');
                        var form_serialize = form.serialize();
                        let valid = true;
                        let error_message = '';

                        data.append('action', 'paypal_payment_process');
                        data.append('form', form_serialize);

                        jQuery(form).find('.checkout_field .required').each(function () {

                            if (jQuery(this).val() === '') {
                                jQuery(this).addClass("et_checkout_error");
                                valid = false;
                                error_message += '<li>' + jQuery(this).attr("placeholder") + '</li>';
                            }
                        });

                        jQuery(form).find('.checkout_field input[pattern]').each(function () {

                            let pattern = new RegExp(jQuery(this).attr("pattern"));

                            if (!pattern.test(String(jQuery(this).val()))) {
                                jQuery(this).addClass("et_checkout_error");
                                valid = false;
                                error_message += '<li>' + jQuery(this).attr("placeholder") + ' (' + jQuery(this).attr("title") + ' )</li>';
                            }
                        });

                        jQuery(form).find('.checkout_field_email #checkout_email_email').each(function () {
                            if (jQuery(this).val() !== '' && !validateEmail(jQuery(this).val())) {
                                jQuery(this).addClass("et_checkout_error");
                                valid = false;
                                error_message += '<li>Email address not valid</li>';
                            }
                        });

                        if (!valid) {
                            jQuery('#card-errors').html('<p>Please, fill in the following fields:</p><ul>' + error_message + '</ul>');
                            jQuery('html, body').animate({
                                scrollTop: jQuery("#card-errors").offset().top - 150
                            }, 500);

                            return actions.reject();
                        } 

                        return fetch(ajax_object.ajaxurl, {
                            method: 'post',
                            body: data,
                            credentials: 'same-origin'
                        }) .then((response) => response.json())
                            .then((data) => {
                                console.log(data);
                                if(data['product_price'] <= 0)
                                {
                                    return createFreeTransaction(form, (redirect) => {       
                                        if (redirect === '') {
                                            jQuery('.modal-checkout').fadeIn('fast');
                                        } else {
                                            window.location.href = redirect;
                                        }
                                        return actions.reject();
                                    });
                                }
                                else{
                                    return actions.resolve();
                                }
                            })
                            .catch((error) => {
                                console.log('Create Order Error:');
                                console.dir(error);
                        });
                    },
                    createOrder: function (data, actions) {

                        var data = new FormData();
                        var form = jQuery('#payment-form').serialize();

                        data.append('action', 'paypal_payment_process');
                        data.append('form', form);

                        return fetch(ajax_object.ajaxurl, {
                            method: 'post',
                            body: data,
                            credentials: 'same-origin'
                        }).then((response) => response.json())
                            .then((data) => {                                
                                return actions.order.create({
                                    purchase_units: [{
                                        amount: {
                                            value: data.product_price,
                                            currency_code: data.product_currency
                                        },
                                    }]
                                });
                            })
                            .catch((error) => {
                                console.log('Payment Error:');
                                console.dir(error);
                            });

                    },
                    onApprove: function (data, actions) {
                        return actions.order.capture().then(function (details) {
                            var data = new FormData();
                            var form = jQuery('#payment-form');
                            var form_serialize = form.serialize();
                            var redirect = form.data("redirect");

                            data.append('action', 'paypal_order_create');
                            data.append('form', form_serialize);
                            data.append('success', true);

                            return fetch(ajax_object.ajaxurl, {
                                method: 'post',
                                body: data,
                                credentials: 'same-origin'
                            }).then((response) => response.json()).then((data) => {
                                if (redirect === '') {
                                    jQuery('.modal-checkout').fadeIn('fast');
                                } else {
                                    window.location.href = redirect;
                                }
                            }).catch((error) => {
                                console.log('Payment Error:');
                                console.dir(error);
                            });
                        });
                    },
                    onError: function (err) {
                        var data = new FormData();
                        var form = jQuery('#payment-form');
                        var form_serialize = form.serialize();
                        var redirect = form.data("redirect");

                        data.append('action', 'paypal_order_create');
                        data.append('form', form_serialize);
                        data.append('success', false);

                        return fetch(ajax_object.ajaxurl, {
                            method: 'post',
                            body: data,
                            credentials: 'same-origin'
                        }).then((response) => response.json()).then((data) => {
                            if (redirect === '') {
                                jQuery('.modal-checkout').fadeIn('fast');
                            } else {
                                window.location.href = redirect;
                            }
                        }).catch((error) => {
                            console.log('Payment Error:');
                            console.dir(error);
                        });
                    }
                });

            paypalButtons.render('#paypal-buttons');

        }

    }
}

function paypalDestroy() {
    if(paypalButtons !== null) {
        paypalButtons.close();
    }else {
        console.log("Not found");
    }
}

function createFreeTransaction(form, callback){

    var data = new FormData();
    var form_serialize = form.serialize();
    data.append('action', 'paypal_order_create');
    data.append('form', form_serialize);
    data.append('success', true);   

    var redirect = form.data("redirect");
    return fetch(ajax_object.ajaxurl, {
        method: 'post',
        body: data,
        credentials: 'same-origin'
    }).then((response) => response.json()).then((data) => {
        return callback(redirect);
    }).catch((error) => {
        console.log('Payment Error:');
        console.dir(error);
    });

}

