// Create a Stripe client.
// 

if(stripe_data.public === ''){
	var element = document.querySelector("#card-element");
	if (element) {
		element.textContent = "Wrong Stripe key. Please, connect your stripe account!";
	}
}else {
	var stripe = Stripe(stripe_data.public);
// Create an instance of Elements.
	var elements = stripe.elements();

	var buttons_element = document.querySelector("#payment-request-button");
	if (buttons_element) {
		var total_price = null;
		var total = document.getElementById("total_price");
		var product_price = document.querySelector("#product_single_price .value");

		if(total) {
			total_price = parseFloat(total.textContent) * 100;
		}else {
			if(product_price) {
				total_price = parseFloat(product_price.textContent) * 100;
			}else {
				total_price = 0;
			}
		}

		var product_name = document.getElementById("product_name_origin").textContent;

		var paymentRequest = stripe.paymentRequest({
			country: 'US',
			currency: 'usd',
			total: {
				label: product_name,
				amount: total_price,
			},
			requestShipping: true,
			requestPayerName: true,
			requestPayerEmail: true,
			requestPayerPhone: true,
			shippingOptions: [
				{
					id: 'no_shipping',
					label: 'No shipping',
					detail: 'No shipping',
					amount: 0,
				}
			]
		});

		var prButton = elements.create('paymentRequestButton', {
			paymentRequest: paymentRequest,
		});

		// Check the availability of the Payment Request API first.
		paymentRequest.canMakePayment().then(function(result) {
			prButton.mount('#payment-request-button');
			if (result) {
				prButton.mount('#payment-request-button');
			}else {
				document.getElementById('payment-request-button').style.display = 'none';
			}
		});

		paymentRequest.on('paymentmethod', function(ev) {

			var form = jQuery('#payment-form');

			jQuery.ajax({
				type: 'POST',
				url: ajax_object.ajaxurl,
				data: {
					'action': 'payment_buttons',
					'payment_id': ev.paymentMethod.id,
					'customer_email': ev.payerEmail,
					'customer_phone': ev.payerPhone,
					'customer_name': ev.payerName,
					'customer_shipping': ev.shippingAddress,
					'card_last_four': ev.paymentMethod.card.last4,
					'card_brand': ev.paymentMethod.card.brand,
					'form': form.serialize(),
				},
				beforeSend: function() {

				},
				success: function (data) {
					jQuery('.modal-errors').html(data);

					if(form.data("redirect") === '') {
						ev.complete('success');
						jQuery('.modal-checkout').fadeIn('fast');
					}else {
						ev.complete('success');
						window.location.href = form.data("redirect");
					}
				}
			});

		});
	}

	var element = document.querySelector("#card-element");
	if(element) {

		var style = {
			base: {
				color: '#32325d',
				fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
				fontSmoothing: 'antialiased',
				fontSize: '16px',
				'::placeholder': {
					color: '#aab7c4'
				}
			},
			invalid: {
				color: '#fa755a',
				iconColor: '#fa755a'
			}
		};

		var card = elements.create('card', {style: style});
		card.mount('#card-element');
	}

}

// Submit the form with the token ID.
function stripeTokenHandler(token) {

	// Insert the token ID into the form so it gets submitted to the server
	var token_field = document.getElementById('stripe_token');
	var last_four = document.getElementById('card_last_four');
	var brand = document.getElementById('card_brand');
	token_field.value = token.id;
	last_four.value = token.card.last4;
	brand.value = token.card.brand;
}